=begin
EGSR - Easy Game Scripting by Ruby "pre-release"
Copyright (C) 2006  Cyross Makoto

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
=end

require 'sdl'
require 'forwardable'
require 'kconv'
require 'rbconfig'

SDL.init(SDL::INIT_VIDEO | SDL::INIT_AUDIO | SDL::INIT_JOYSTICK)

=begin
= EGSRW[
EGSRŎgpSẴW[ENX͑SEGSRW[ɑĂ
ȂAɐĂȂA{W[ŎgPʂ́A
WFsNZP
ԁFt[P
ƂȂĂB
--- EGSR::getOSName
XNvgsĂzXgOS̖OԂB
Windowsn̏ꍇ"win"
Linuxn̏ꍇ"linux"ƕԂ
--- EGSR::setTitle(title)
EBhẼ^CgtitleɕύX
--- EGSR::update
ʁA̓foCXꊇčXV
=end
module EGSR

=begin
--- EGSRError
EGSRŋNONXB
ǂ̂悤Ȏނ̃G[łEGSRErrorNX̗OƂĕԂ
=end
  class EGSRError < Exception
  end
  
  @@osName = "other"
  if Config::CONFIG["target_os"] =~ /win/ # Windows / Cygwin / MingWin
    @@osName = "win"
  elsif Config::CONFIG["target_os"] =~ /linux/ # linux
    @@osName = "linux"
  else
    stderr.print "Sorry, EGSR works only Windows and Linux...\n"
    exit(1)
  end
  
  def EGSR::getOSName
    @@osName
  end
  
  def EGSR::setTitle(title)
    if title.class != String
      raise EGSRError.new("Title is not String! : "+title.class().to_s())
    end
    if getOSName == "win"
      SDL::WM.setCaption(title.to_s().tosjis(), "")
    else
      SDL::WM.setCaption(title.to_s().toeuc(), "")
    end
  end
  
=begin
=EGSR::RectNX
EGSRŎgp`ǗNX

--- EGSR::Rect.new(x, y, w, h)
EGSR::RectNX̃RXgN^B
x, y, w, h͂ꂼ`̍XWAYWA`A`

--- EGSR::Rect#x
--- EGSR::Rect#y
--- EGSR::Rect#w
--- EGSR::Rect#h
`x, y, w, hԂ

--- EGSR::Rect#rect
NXɊi[Ă[x,y,w,h]̔zƂĕԂ

=end
  class Rect # structure class
    attr_accessor :x, :y, :w, :h
    def initialize(x, y, w, h)
      @x, @y = x, y
      @w, @h = w, h
    end
    
    def rect
      [@x, @y, @w, @h]
    end
  end
  
=begin
=EGSR::ColorNX
Fi[NX

--- EGSR::Color.new(r, g, b)
--- EGSR::Color.new(code)
ColorNX̃RXgN^B
r,g,b́AԁA΁A̊evf̒l(0`255)A
codéA0x00rrggbb̊eoCg̒l4oCgɂ܂Ƃ߂l(ȍ~AuJ[R[hvƂ)B

--- EGSR::cc2rgb(cc)
ccƂė^ꂽJ[R[hԁA΁A̊evf̔zɕϊ

--- EGSR::rgb2cc(r, g, b)
r, g, bƂė^ꂽevfJ[R[hɕϊ

--- EGSR::Color#r
--- EGSR::Color#g
--- EGSR::Color#b
--- EGSR::Color#ccode
ClassNX̃IuWFNgɊi[ĂԁA΁AAR[h
lԂ

--- EGSR::Color#list
ClassNX̃IuWFNgɊi[ĂԁA΁A̒l
[r, g, b]̔zƂĕԂ

=end
  class Color
    attr_accessor :ccode, :r, :g, :b
    
    ShiftR = 0xffff
    ShiftG = 0xff
    
    def Color::cc2rgb(cc)
      [cc / ShiftR, (cc % ShiftR) / ShiftG, cc % ShiftG]
    end
    
    def Color::rgb2cc(r, g, b)
      r * ShiftR + g * ShiftG + b
    end
    
    def initialize(*list)
      @ccode = 0
      @r = 0
      @g = 0
      @b = 0
      if list.length < 3 # Color Code
        @ccode = list[0]
        @r, @g, @b = Color.cc2rgb(@ccode)
      else               # R,G,B
        @r, @g, @b = *list
        @ccode = Color.rgb2cc(@r, @g, @b)
      end
    end
    
    def list
      [@r, @g, @b]
    end
  end

=begin
=EGSR::SpriteListNX
XvCgŜǗNX
ʂɃXvCgꊇĕ`悷ۂɗp
EGSRŎgp邽ߐ͊
=end
  
  class SpriteList
    extend Forwardable
    
    def initialize
      @hash = Hash.new
    end
    
    def_delegators(:@hash, :clear)
    
    def add(sprite)
      if @hash[sprite.dp] == nil
        @hash[sprite.dp] = Hash.new
        @hash[sprite.dp][sprite.id] = sprite
      elsif @hash[sprite.dp][sprite.id] == nil
        @hash[sprite.dp][sprite.id] = sprite
      end
    end
    
    def replaceDp(sprite, old)
      if @hash[old] == nil
        return
      end
      if @hash[old][sprite.id] != nil
        @hash[old].delete(sprite.id)
      end
      add(sprite)
    end
    
    def remove(sprite)
      @hash[sprite.dp].delete(sprite.id)
    end
    
    def getList
      @hash = @hash.reject{|k, v| @hash[k].empty?() }
      list = Array.new
      @hash.keys.sort.each{|k|
        if @hash[k] != nil
          @hash[k].keys.sort.each{|kk|
            if @hash[k][kk] != nil && @hash[k][kk].visible
              list.push(@hash[k][kk])
            end
          }
        end
      }
      list
    end
  end
  
=begin
=EGSR::FontNX
ʂɃeLXg`悷ۂɗptHgǗNX
TrueTypetHgABDFtHgg
ł́AetHggq("ttf/ttc","bdf")Ŕʂ邽߁A
gptHgt@Cɂ͋C邱

ȂAeLXgɂ͈ȉ̃}NgpłB
{r, g, b, s}{eLXg}
ʂň͂܂ꂽ"eLXg"̕`F[r,g,b]ŗ^lɁA
̑傫sɕύXĕ`悷Bs0̂Ƃ̓TCYςɕ`悷
ȂATCYςۂɕ`͈͍̈̔͂lĂȂƂɒӂ

--- EGSR::Font.systemFont
WŎgptHgԂ
--- EGSR::Font.systemFont=(font)
WŎgptHgo^
EGSR::systemFont\bhgpۂɂ͕Ko^Kv
--- EGSR::Font.new(fname, size=16)
tHgt@CfnamẽtHgTCYsize(ftHg16sNZ)Ŏgpł悤
o^B
--- EGSR::Font#setCodingSystem(code)
o^ĂtHgBDF̏ꍇAR[ho^
gpł̂SDL::SJISASDL::EUCASDL::JIS
--- EGSR::Font#add(fname)
o^ĂtHgBDF̏ꍇAgpłtHgǉ
--- EGSR::Font#size
o^ĂtHg̑傫Ԃ
--- EGSR::Font#size=(sz)
o^ĂtHg̑傫szɕύX
--- EGSR::Font#textSize(str)
stro^ĂtHgŕ\̉ƍ
[w, h]̔zŕԂ
--- EGSR::Font#setColor(r, g, b)
o^ĂtHg̕`Fr,g,b3vfŐݒ肷
--- EGSR::Font#getColor
o^ĂtHg̕`F[r, g, b]̔zŕԂ
--- EGSR::Font#setStyle(nm = true, bl = false, it = false, ul = false)
o^ĂtHgTrueTypȅꍇAtHg̃X^Cݒ肷A
nmł͕WX^CAblł̓{[hAitł͎Α(C^bN)Aulł͉(A_[C)
gp邩ǂݒł
--- EGSR::Font#getStyle
o^ĂtHg̃X^CA[nm, bl, it, ul]4vf̔zƂĕԂ
--- EGSR::Font#drawText(dst, str, x=0, y=0)
--- EGSR::Font#drawTextMild(dst, str, x=0, y=0)
strAo^ĂtHgŁAdstŎĂrbg}bv̈1s`悷
`̎n_x,yŎw肷
`悵Ƃ̍ő̍(16hbg24ǂƂŕ`悵Ƃ"24")Ԃ
drawTextMild\bh́AtHg`悷ۂɃA`GCAXs
--- EGSR::Font#drawMultiLineText(dst, str, x=0, y=0, sp=0, h=0)
--- EGSR::Font#drawMultiLineTextMild(dst, str, x=0, y=0)
s̕strAo^ĂtHgŁAdstŎĂrbg}bv̈̎ẅɕ`悷
`̎n_x,yŁAsԂ̃Xy[XspŁA`̈̍hŎw肷
`̈ɕ`ȂԂ
drawMultiLineTextMild\bh́AtHg`悷ۂɃA`GCAXs
=end

  class Font
    SDL::TTF.init
    extend Forwardable
    attr_reader :size
    
    @@systemFont = nil
    
    def Font::systemFont
      @@systemFont
    end
    
    def Font::systemFont=(font)
      @@systemFont = font
    end
    
    def _setStyle
      tmp = 0
      if @normal
        tmp = tmp | SDL::TTF::STYLE_NORMAL
      end
      if @bold
        tmp = tmp | SDL::TTF::STYLE_BOLD
      end
      if @italic
        tmp = tmp | SDL::TTF::STYLE_ITALIC
      end
      if @underline
        tmp = tmp | SDL::TTF::STYLE_UNDERLINE
      end
      tmp
    end
    
    def getFontDirListLinux
      list = Array.new()
# 2006.02.11 Cyross Makoto
# Can't execute by Fedora Core 4
#      File.open("/etc/X11/XF86Config", "r"){|f|
#        while !(f.eof?()) do
#          l = f.readline()
#          if l =~ /^[\s\t]*FontPath[\s\t]*\"(.+)\"/
#            list.push($1)
#          end
#        end
#      }
      list
    end
    
    def getFontFilePathTTF(n)
      osn = EGSR::getOSName
      nx = n.tr_s('\\', '/')
      if osn == "win"
        if File.exist?(nx)
          return n
        elsif File.exist?("./"+nx)
          return "./"+nx
        elsif File.exist?("c:/windows/fonts/"+nx)
          return "c:/windows/fonts/"+nx
        end
      elsif osn == "linux"
        if File.exist?(nx)
          return nx
        elsif File.exist?("./"+nx)
          return "./"+nx
        else
          getFontDirListLinux().each{|d|
            if File.exist?(d + "/" + nx)
              return d + "/" + nx
            end
          }
        end
      end
      raise EGSRError.new("Cannot Find Font File! : #{n}")
    end
    
    def getFontFilePathBDF(n)
      osn = EGSR::getOSName
      nx = n.tr_s('\\', '/')
      if osn == "win"
        if File.exist?(nx)
          return n
        elsif File.exist?("./"+nx)
          return "./"+nx
        end
      elsif osn == "linux"
        if File.exist?(nx)
          return nx
        elsif File.exist?("./"+nx)
          return "./"+nx
        else
          getFontDirListLinux().each{|d|
            if File.exist?(d + "/" + nx)
              return d + "/" + nx
            end
          }
        end
      end
      raise EGSRError.new("Cannot Find Font File! : #{n}")
    end
    
    private :_setStyle, :getFontDirListLinux, :getFontFilePathTTF, :getFontFilePathBDF
    
    def initialize(fname, size=16)
      @size = size
      @col = [255, 255, 255]
      @normal = true
      @bold = false
      @italic = false
      @underline = false
      @style = _setStyle()
      @fname = ""
      @font = nil
      if fname =~ /\.tt[fc]$/ # truetype font
        @fname = getFontFilePathTTF(fname)
        @font = SDL::TTF.open(@fname, @size)
        @font.style = @style
      else # bitmap font
        @fname = getFontFilePathBDF(fname)
        @font = SDL::Kanji.open(@fname, @size)
        osn = EGSR::getOSName
        if osn == "win"
          @font.setCodingSystem(SDL::Kanji::SJIS)
        elsif osn == "linux"
          @font.setCodingSystem(SDL::Kanji::EUC)
        end
      end
    end
    
    def setCodingSystem(code)
      return if @font.class == SDL::TTF
      @font.setCodingSystem(code)
    end
    
    def add(fname)
      return if @font.class == SDL::TTF
      path = getFontFilePathBDF(fname)
      @font = self.add(path)
    end
    
    def size
      @size
    end
    
    def size=(sz)
      @size = sz
      if @font.class == SDL::TTF
        @font = SDL::TTF.open(@fname, @size)
      else
        @font = SDL::Kanji.open(@fname, @size)
      end
      @font.style = @style
    end
    
    def textSize(str)
      if @font.class == SDL::TTF
        @font.textSize(str.toutf8())
      else # bitmap font
        [@font.textwidth(str),@font.height]
      end
    end
    
    def setColor(r, g, b)
      @col = [r, g, b]
    end
    
    def getColor
      @col
    end
    
    def setStyle(nm = true, bl = false, it = false, ul = false)
      @normal, @bold, @italic, @underline = [nm, bl, it, ul]
      @style = _setStyle()
      if @font.class == SDL::TTF
        @font.style = @style
      end
    end
    
    def getStyle
      [@normal, @bold, @italic, @underline]
    end
    
    def drawText(dst, str, x=0, y=0)
      xx = x
      maxh = self.size
      if @font.class == SDL::TTF
        while str =~ /\{\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*\}\{(.+)\}/ do
          if $` != nil
            @font.drawSolidUTF8(dst, $`.toutf8(), xx, y, @col[0], @col[1], @col[2])
            xx = xx + (@font.textSize($`.toutf8()))[0]
          end
          c1, c2, c3 = *@col
          if $1.to_i() != -1
            c1 = $1.to_i()
          end
          if $2.to_i() != -1
            c2 = $2.to_i()
          end
          if $3.to_i() != -1
            c3 = $3.to_i()
          end
          s = $4.to_i()
          f2 = @font
          if s != 0
            maxh = s if s > maxh
            f2 = SDL::TTF.open(@fname, s)
            f2.style = @style
          end
          f2.drawSolidUTF8(dst, $5.toutf8(), xx, y, c1, c2, c3)
          xx = xx + (f2.textSize($5.toutf8()))[0]
          str = $'
        end
        if str != ""
          @font.drawSolidUTF8(dst, str.toutf8(), xx, y, @col[0], @col[1], @col[2])
        end
      else # bitmap font
        str = if EGSR::getOSName == "win"
                str.tosjis()
              else
                str.toeuc()
              end
        while str =~ /\{\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*\}\{(.+)\}/ do
          if $` != nil
            @font.put(dst, $`, xx, y, @col[0], @col[1], @col[2])
            xx = xx + @font.textwidth($`)
          end
          c1, c2, c3 = *@col
          if $1.to_i() != -1
            c1 = $1.to_i()
          end
          if $2.to_i() != -1
            c2 = $2.to_i()
          end
          if $3.to_i() != -1
            c3 = $3.to_i()
          end
          s = $4.to_i()
          f2 = @font
          if s != 0
            maxh = s if s > maxh
            f2 = SDL::Kanji.open(@fname, s)
          end
          f2.put(dst, $5, xx, y, c1, c2, c3)
          xx = xx + f2.textwidth($5)
          str = $'
        end
        if str != ""
          @font.put(dst, str, xx, y, @col[0], @col[1], @col[2])
        end
      end
      maxh
    end
    
    def drawMultiLineText(dst, str, x=0, y=0, sp=0, h=0)
      lines = str.split(/\n/)
      rline = ""
      yp = y
      lines.each{|l|
        if h == 0
          hh = drawText(dst, l, x, yp)
          yp = yp + hh + sp
        elsif yp + @size < h
          hh = drawText(dst, l, x, yp)
          yp = yp + hh + sp
        else
          rline = rline + l + "\n"
        end
      }
      rline
    end

    def drawTextMild(dst, str, x=0, y=0)
      xx = x
      maxh = self.size
      if @font.class == SDL::TTF
        while str =~ /\{\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*\}\{(.+)\}/ do
          if $` != nil
            @font.drawBlendedUTF8(dst, $`.toutf8(), xx, y, @col[0], @col[1], @col[2])
            xx = xx + (@font.textSize($`.toutf8()))[0]
          end
          c1, c2, c3 = *@col
          if $1.to_i() != -1
            c1 = $1.to_i()
          end
          if $2.to_i() != -1
            c2 = $2.to_i()
          end
          if $3.to_i() != -1
            c3 = $3.to_i()
          end
          s = $4.to_i()
          f2 = @font
          if s != 0
            maxh = s if s > maxh
            f2 = SDL::TTF.open(@fname, s)
            f2.style = @style
          end
          f2.drawBlendedUTF8(dst, $5.toutf8(), xx, y, c1, c2, c3)
          xx = xx + (f2.textSize($5.toutf8()))[0]
          str = $'
        end
        if str != ""
          @font.drawBlendedUTF8(dst, str.toutf8(), xx, y, @col[0], @col[1], @col[2])
        end
      else # bitmap font
        str = if EGSR::getOSName == "win"
                str.tosjis()
              else
                str.toeuc()
              end
        while str =~ /\{\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*\}\{(.+)\}/ do
          if $` != nil
            @font.put(dst, $`, xx, y, @col[0], @col[1], @col[2])
            xx = xx + @font.textwidth($`)
          end
          c1, c2, c3 = *@col
          if $1.to_i() != -1
            c1 = $1.to_i()
          end
          if $2.to_i() != -1
            c2 = $2.to_i()
          end
          if $3.to_i() != -1
            c3 = $3.to_i()
          end
          s = $4.to_i()
          f2 = @font
          if s != 0
            maxh = s if s > maxh
            f2 = SDL::Kanji.open(@fname, s)
          end
          f2.put(dst, $5, xx, y, c1, c2, c3)
          xx = xx + f2.textwidth($5)
          str = $'
        end
        if str != ""
          @font.put(dst, str, xx, y, @col[0], @col[1], @col[2])
        end
      end
      maxh
    end
    
    def drawMultiLineTextMild(dst, str, x=0, y=0, sp=0, h=0)
      lines = str.split(/\n/)
      rline = ""
      yp = y
      lines.each{|l|
        if h == 0
          hh = drawTextMild(dst, l, x, yp)
          yp = yp + hh + sp
        elsif yp + @size < h
          hh = drawTextMild(dst, l, x, yp)
          yp = yp + hh + sp
        else
          rline = rline + l + "\n"
        end
      }
      rline
    end
  end
  
=begin
=EGSR::ScreenW[
EGSRŕ\ʂɊւ郂W[
--- EGSR::Screen.Width萔
EGSRŎgpʂ̕(l640)
--- EGSR::Screen.Height萔
EGSRŎgpʂ̍(l480)
--- EGSR::Screen.getFpsCnt
݂FPSlԂ
--- EGSR::Screen.fps
EGSRŎsۂɐݒ肵ĂFPSlԂ
--- EGSR::Screen.fps=(val)
EGSRŎs鎞ɏƂȂFPSlvalɕύX
val0̂Ƃ́AEGSRFPSƔF
--- EGSR::Screen.fpsView
--- EGSR::Screen.fpsView=(val)
ʍFPSl\邩tO擾/ݒ肷
--- EGSR::Screen.screen
EGSRŎgpĂʃIuWFNg擾
EGSRŎgp邽߂ɗpӂĂ
--- EGSR::Screen.w
ʂ̉ԂBEGSR::Screen.Width萔̒lƓ
--- EGSR::Screen.h
ʂ̍ԂBEGSR::Screen.Height萔̒lƓ
--- EGSR::Screen.update
XvCg``施߁AeLXg`施߁AGtFNgꊇčs
--- EGSR::Screen.freeze
ʂ̕`~
freezeĂԂ͉ʂ̍XVsȂ
qtrasitionȂ~Ă
--- EGSR::Screen.freeze?
ʂ̕`~Ă邩tO
--- EGSR::Screen.trasition
freezẻʂ̕`ĊJ
--- EGSR::Screen.fadeIn(pat = 8, wait = 10)
--- EGSR::Screen.fadeOut(pat = 8, wait = 10)
ʂpatŎiKAwaitŗ^ԒP(t[)ňÓ]EA
--- EGSR::Screen.whiteIn(pat = 8, wait = 10)
--- EGSR::Screen.whiteOut(pat = 8, wait = 10)
ʂpatŎiKAwaitŗ^ԒP(t[)ŔFɕωEA
--- EGSR::Screen.effecting?
ʂɃGtFNg|Ă邩(fadeInAfadeOutAwhiteInAwhiteOut)tO
=end
  
  module Screen
    Width = 640
    Height = 480
    BPP = 0
    FpsMax = 1000
    ScreenFlag = SDL::HWSURFACE | SDL::DOUBLEBUF | SDL::ANYFORMAT
    
    def Screen::getFpsCnt
      if @@fps == 0
        return 0
      end
      (FpsMax + (@@fps+ 1) / 2) / @@fps
    end
    
    @@fps = 0 # fps=0 : no-limit
    @@fpsView = false
    @@fpscnt = Screen::getFpsCnt
    @@t = 0
    @@sprites = SpriteList.new
    @@freezing  = false
    @@effPats   = 0
    @@effWait   = 0
    @@effCnt    = 0
    @@effAlpha  = 0
    @@effAmount = 0
    @@effecting = false
    
    @@screen = nil
    if SDL.checkVideoMode(Width, Height, BPP, ScreenFlag)
      @@screen = SDL.setVideoMode(Width, Height, BPP, ScreenFlag)
    elsif  SDL.checkVideoMode(Width, Height, BPP, ScreenFlag)
      @@screen = SDL.setVideoMode(Width, Height, BPP, ScreenFlag)
    else
      print "Sorry, this system not supported display...\n";
      exit(1)
    end
    
    @@buf = SDL::Surface.new(SDL::HWSURFACE | SDL::SRCCOLORKEY | SDL::SRCALPHA, Width, Height, @@screen)
    @@buf = @@buf.displayFormat
    # for effect
    @@eff = SDL::Surface.new(SDL::HWSURFACE | SDL::SRCCOLORKEY | SDL::SRCALPHA, Width, Height, @@screen)
    @@eff.setAlpha(SDL::SRCALPHA, 0)
    @@eff = @@eff.displayFormat
    
    def Screen::fps
      @@fps
    end
    
    def Screen::fps=(val)
      @@fps = val
      if @@fps == 0
        @@fpscnt = 0
      else
        @@fpscnt = Screen::getFpsCnt
      end
    end
    
    def Screen::fpsView
      @@fpsView
    end
    
    def Screen::fpsView=(val)
      @@fpsView = val
    end
    
    def Screen::screen
      @@screen
    end
    
    def Screen::w
      @@screen.w
    end
    
    def Screen::h
      @@screen.h
    end
    
    def Screen::update
      t = SDL.getTicks
      if @@fps > 0
        cnt = t - @@t
        while cnt < @@fpscnt
          t = SDL.getTicks
          cnt = t - @@t
        end
      end
      if !(@@freezing)
        l = Window.getList
        l.each{|ww|
          if ww != nil
            ww.drawWindow
          end
        }
        l = Sprite.getList
        l.each{|s|
          @@screen.setClipRect(s.viewPort.x, s.viewPort.y, s.viewPort.w, s.viewPort.h)
          s.update
          if s.bitmap != nil
            if s.scaleX != 1.0 || s.scaleY != 1.0 || s.angle != 0
             SDL.transformBlit(s.bitmap, @@screen, s.angle, s.scaleX, s.scaleY, s.centerX * s.scaleX, s.centerY * s.scaleY, s.x + s.centerX * s.scaleX, s.y + s.centerY * s.scaleY, 0)
            else
              SDL.blitSurface(s.bitmap, s.ox, s.oy, s.ow, s.oh, @@screen, s.x, s.y)
            end
          end
          if s.drawBlock != nil
            @@screen.lock
            s.drawBlock.call(@@screen)
            @@screen.unlock
            @@screen.setClipRect(0, 0, Width, Height)
          end
          if s.font != nil && s.context != nil
            @@screen.setClipRect(s.x + s.textMarginX, s.y + s.textMarginY, s.w - s.textMarginX * 2, s.h - s.textMarginY * 2)
            s.rcontext = s.font.drawMultiLineTextMild(@@screen, s.context, s.x + s.textMarginX, s.y + s.textMarginY, 0, s.h - s.textMarginY * 2)
          end
          @@screen.setClipRect(0, 0, Width, Height)
          SDL.blitSurface(@@screen, 0, 0, 0, 0, @@buf, 0, 0)
        }
      else
        SDL.blitSurface(@@buf, 0, 0, 0, 0, @@screen, 0, 0)
      end
      if @@effecting
        if @@effCnt == 0
          SDL.blitSurface(@@eff, 0, 0, 0, 0, @@screen, 0, 0)
          @@effAlpha = @@effAlpha + @@effAmount
          @@effAlpha = 0 if @@effAlpha < 0
          @@effAlpha = 255 if @@effAlpha > 255
          @@eff.setAlpha(SDL::SRCALPHA, @@effAlpha)
          @@eff = @@eff.displayFormat
          @@effCnt = @@effWait
          @@effPats = @@effPats - 1
        else
          SDL.blitSurface(@@eff, 0, 0, 0, 0, @@screen, 0, 0)
          @@effCnt = @@effCnt - 1
        end
        if @@effPats == 0
          @@effecting = false
        end
      else
        SDL.blitSurface(@@eff, 0, 0, 0, 0, @@screen, 0, 0)
      end
      if @@fpsView
        Font.systemFont.drawText(@@screen, ((FpsMax/(t - @@t)).to_s() + " fps"), 0, 0) if Font.systemFont != nil
      end
      @@t = t
      @@screen.flip
      @@screen.fillRect(0,0,@@screen.w,@@screen.h,[0,0,0])
    end
    
    def Screen::freeze
      @@freezing = true
    end
    
    def Screen::freezing?
      @@freezing
    end
    
    def Screen::trasition
      @@freezing = false
    end
    
    def Screen::fadeIn(pat = 8, wait = 10)
      @@effecting = true
      @@effPats   = pat
      @@effWait   = wait
      @@effCnt    = @@effWait
      @@effAlpha  = 0
      @@effAmount = 256 / @@effPats
      @@eff.fillRect(0,0,@@screen.w,@@screen.h,[0,0,0])
      @@eff.setAlpha(SDL::SRCALPHA, @@effAlpha)
      @@eff = @@eff.displayFormat
    end
    
    def Screen::fadeOut(pat = 8, wait = 10)
      @@effecting = true
      @@effPats   = pat
      @@effWait   = wait
      @@effCnt    = @@effWait
      @@effAlpha  = 255
      @@effAmount = -(256 / @@effPats)
      @@eff.fillRect(0,0,@@screen.w,@@screen.h,[0,0,0])
      @@eff.setAlpha(SDL::SRCALPHA, @@effAlpha)
      @@eff = @@eff.displayFormat
    end
    
    def Screen::whiteIn(pat = 8, wait = 10)
      @@effecting = true
      @@effPats   = pat
      @@effWait   = wait
      @@effCnt    = @@effWait
      @@effAlpha  = 0
      @@effAmount = 256 / @@effPats
      @@eff.fillRect(0,0,@@screen.w,@@screen.h,[255,255,255])
      @@eff.setAlpha(SDL::SRCALPHA, @@effAlpha)
      @@eff = @@eff.displayFormat
    end
    
    def Screen::whiteOut(pat = 8, wait = 10)
      @@effecting = true
      @@effPats   = pat
      @@effWait   = wait
      @@effCnt    = @@effWait
      @@effAlpha  = 255
      @@effAmount = -(256 / @@effPats)
      @@eff.fillRect(0,0,@@screen.w,@@screen.h,[255,255,255])
      @@eff.setAlpha(SDL::SRCALPHA, @@effAlpha)
      @@eff = @@eff.displayFormat
    end
    
    def Screen::effecting?
      @@effecting
    end
  end

=begin
=EGSR::BitmapNX
摜̈tOBXvCgBitmapgpē\t
ۂSDL::SurfaceNXp̂Ȃ̂ŁASDL::SurfaceNXŒ`Ă`施߂SăT|[gB
AA͌qEGSR::Sprite.drawBlockvpeBɃubNƂēo^댯Ȃ

--- EGSR:Bitmap.create(w, h)
Bitmapw肵Eō쐬

=end

  class Bitmap < SDL::Surface
    def Bitmap.create(w, h)
      SDL::Surface.new(SDL::HWSURFACE | SDL::SRCCOLORKEY | SDL::SRCALPHA, w, h, Screen::screen)
    end
  end

=begin
=EGSR::InputW[
EGSRŎgpĂ̓foCXǗĂ郂W[
̓foCX̓L[{[hƃWCpbhz肵Ă
WCpbĥP`U{^̓L[{[hZ,X,C,A,S,DL[ɑΉĂ
WCpbh̕L[̓eL[2,4,6,8ɑΉĂ
AAL[{[hEscapeL[ASpaceL[AEnterL[̓WCpbhɂ͑ΉĂȂ
--- EGSR::Input.update
̓foCXXV
--- EGSR::Input.triggerDir
L[Ă[,,E,]4vf̐l̔zŎ
ꂼAĂƂ1AĂȂƂ0
--- EGSR::Input.pushedDir
L[[,,E,]4vf̐l̔zŎ
ꂼAƂ1Aɉ܂܂ĂȂƂ0
L[ĂԁAtrigger͂1̂܂܂Apushedł͉uԂ̂1ƂȂ
--- EGSR::Input.triggerBtn
{^Ăӏ[1ԁA2ԁA3ԁA4ԁA5ԁA6]6vf̐l̔zŎ
ꂼAĂƂ1AĂȂƂ0
--- EGSR::Input.pushedBtn
{^Ăӏ[1ԁA2ԁA3ԁA4ԁA5ԁA6]6vf̐l̔zŎ
ꂼAƂ1Aɉ܂܂ĂȂƂ0
--- EGSR::Input.triggerSpc?
Xy[XL[ĂƂtrueԂ
--- EGSR::Input.triggerEnter?
G^[L[ĂƂtrueԂ
--- EGSR::Input.triggerEscape?
GXP[vL[ĂƂtrueԂ
--- EGSR::Input.pushedSpc?
Xy[XL[ƂtrueԂ
--- EGSR::Input.pushedEnter?
G^[L[ƂtrueԂ
--- EGSR::Input.pushedEscape?
GXP[vL[ƂtrueԂ
--- EGSR::Input.quit?
EBhÉuv{^ȂǂtrueԂ
=end

  module Input
    @@joy = nil
    if SDL::Joystick.num >= 1
      @@joy = SDL::Joystick.open(0)
    end
    @@quit = false
    @@trigger_spc = false
    @@trigger_ent = false
    @@trigger_esc = false
    @@pushed_spc = false
    @@pushed_ent = false
    @@pushed_esc = false
    @@pushed_spc_pre = false
    @@pushed_ent_pre = false
    @@pushed_esc_pre = false
    @@trigger_dir = [0, 0, 0, 0]
    @@trigger_btn = [0, 0, 0, 0, 0, 0]
    @@pushed_dir = [0, 0, 0, 0]
    @@pushed_btn = [0, 0, 0, 0, 0, 0]
    @@pushed_dir_pre = [0, 0, 0, 0]
    @@pushed_btn_pre = [0, 0, 0, 0, 0, 0]
    @@trigger_mouse_pos = [0, 0]
    @@trigger_mouse_btn = [0, 0, 0]
    @@btn_list = [SDL::Key::Z, SDL::Key::X, SDL::Key::C,
                  SDL::Key::A, SDL::Key::S, SDL::Key::D]
    @@dir_list = [SDL::Key::KP2, SDL::Key::KP4, SDL::Key::KP6, SDL::Key::KP8]
    
    def Input::update
      SDL::Joystick.updateAll
      @@pushed_btn_pre.length.times{|p|
        if @@pushed_btn_pre[p] == 1
          @@pushed_btn[p] = 0
        end
      }
      @@pushed_dir_pre.length.times{|p|
        if @@pushed_dir_pre[p] == 1
          @@pushed_dir[p] = 0
        end
      }
      if @@pushed_spc_pre == true
        @@pushed_spc = false
      end
      if @@pushed_ent_pre == true
        @@pushed_ent = false
      end
      if @@pushed_ent_pre == true
        @@pushed_ent = false
      end
      while e = SDL::Event2.poll
        case e
        when SDL::Event2::Quit
          @@quit = true
        when SDL::Event2::KeyDown
          @@btn_list.length.times{|b|
            if e.sym == @@btn_list[b]
              @@trigger_btn[b] = 1
              if @@pushed_btn_pre[b] == 0
                @@pushed_btn[b] = 1
                @@pushed_btn_pre[b] = 1
              end
            end
          }
          @@dir_list.length.times{|d|
            if e.sym == @@dir_list[d]
              @@trigger_dir[d] = 1
              if @@pushed_dir_pre[d] == 0
                @@pushed_dir[d] = 1
                @@pushed_dir_pre[d] = 1
              end
            end
          }
          if e.sym == SDL::Key::RETURN
            @@trigger_ent = true
            if @@pushed_ent_pre == false
              @@pushed_ent = true
              @@pushed_ent_pre = true
            end
          elsif e.sym == SDL::Key::SPACE
            @@trigger_spc = true
            if @@pushed_spc_pre == false
              @@pushed_spc = true
              @@pushed_spc_pre = true
            end
          elsif e.sym == SDL::Key::ESCAPE
            @@trigger_esc = true
            if @@pushed_esc_pre == false
              @@pushed_esc = true
              @@pushed_esc_pre = true
            end
          end
        when SDL::Event2::KeyUp
          @@btn_list.length.times{|b|
            if e.sym == @@btn_list[b]
              @@trigger_btn[b] = 0
              @@pushed_btn[b] = 0
              @@pushed_btn_pre[b] = 0
            end
          }
          @@dir_list.length.times{|d|
            if e.sym == @@dir_list[d]
              @@trigger_dir[d] = 0
              @@pushed_dir[d] = 0
              @@pushed_dir_pre[d] = 0
            end
          }
          if e.sym == SDL::Key::RETURN
            @@trigger_ent = false
            @@pushed_ent = false
            @@pushed_ent_pre = false
          elsif e.sym == SDL::Key::SPACE
            @@trigger_spc = false
            @@pushed_spc = false
            @@pushed_spc_pre = false
          elsif e.sym == SDL::Key::ESCAPE
            @@trigger_esc = false
            @@pushed_esc = false
            @@pushed_esc_pre = false
          end
        when SDL::Event2::MouseMotion
        when SDL::Event2::MouseButtonDown
        when SDL::Event2::MouseButtonUp
        when SDL::Event2::JoyAxis
          if e.axis == 0
            if e.value == -1
              @@trigger_dir[1] = 0
              @@trigger_dir[2] = 0
              @@pushed_dir[1] = 0
              @@pushed_dir_pre[1] = 0
              @@pushed_dir[2] = 0
              @@pushed_dir_pre[2] = 0
            elsif e.value == -32768
              @@trigger_dir[1] = 1
              if @@pushed_dir_pre[1] == 0
                @@pushed_dir[1] = 1
                @@pushed_dir_pre[1] = 1
              end
            elsif e.value == 32767
              @@trigger_dir[2] = 1
              if @@pushed_dir_pre[2] == 0
                @@pushed_dir[2] = 1
                @@pushed_dir_pre[2] = 1
              end
            end
          elsif e.axis == 1
            if e.value == -1
              @@trigger_dir[0] = 0
              @@trigger_dir[3] = 0
              @@pushed_dir[0] = 0
              @@pushed_dir_pre[0] = 0
              @@pushed_dir[3] = 0
              @@pushed_dir_pre[3] = 0
            elsif e.value == -32768
              @@trigger_dir[3] = 1
              if @@pushed_dir_pre[3] == 0
                @@pushed_dir[3] = 1
                @@pushed_dir_pre[3] = 1
              end
            elsif e.value == 32767
              @@trigger_dir[0] = 1
              if @@pushed_dir_pre[0] == 0
                @@pushed_dir[0] = 1
                @@pushed_dir_pre[0] = 1
              end
            end
          end
        when SDL::Event2::JoyHat
          if e.value == SDL::Joystkck::HAT_CENTERED
            break
          end
          @@trigger_dir = @@trigger_dir.collect{|i| 0}
          if e.value == SDL::Joystick::HAT_DOWN
            @@trigger_dir[0] = 1
            if @@pushed_dir_pre[0] == 0
              @@pushed_dir[0] = 1
              @@pushed_dir_pre[0] = 1
            end
          elsif e.value == SDL::Joystick::HAT_LEFT
            @@trigger_dir[1] = 1
            if @@pushed_dir_pre[1] == 0
              @@pushed_dir[1] = 1
              @@pushed_dir_pre[1] = 1
            end
          elsif e.value == SDL::Joystick::HAT_RIGHT
            @@trigger_dir[2] = 1
            if @@pushed_dir_pre[2] == 0
              @@pushed_dir[2] = 1
              @@pushed_dir_pre[2] = 1
            end
          elsif e.value == SDL::Joystick::HAT_UP
            @@trigger_dir[3] = 1
            if @@pushed_dir_pre[3] == 0
              @@pushed_dir[3] = 1
              @@pushed_dir_pre[3] = 1
            end
          elsif e.value == SDL::Joystick::HAT_LEFTDOWN
            @@trigger_dir[0] = 1
            @@trigger_dir[1] = 1
            if @@pushed_dir_pre[0] == 0
              @@pushed_dir[0] = 1
              @@pushed_dir_pre[0] = 1
            end
            if @@pushed_dir_pre[1] == 0
              @@pushed_dir[1] = 1
              @@pushed_dir_pre[1] = 1
            end
          elsif e.value == SDL::Joystick::HAT_RIGHTDOWN
            @@trigger_dir[0] = 1
            @@trigger_dir[2] = 1
            if @@pushed_dir_pre[0] == 0
              @@pushed_dir[0] = 1
              @@pushed_dir_pre[0] = 1
            end
            if @@pushed_dir_pre[2] == 0
              @@pushed_dir[2] = 1
              @@pushed_dir_pre[2] = 1
            end
          elsif e.value == SDL::Joystick::HAT_LEFTUP
            @@trigger_dir[3] = 1
            @@trigger_dir[1] = 1
            if @@pushed_dir_pre[3] == 0
              @@pushed_dir[3] = 1
              @@pushed_dir_pre[3] = 1
            end
            if @@pushed_dir_pre[1] == 0
              @@pushed_dir[1] = 1
              @@pushed_dir_pre[1] = 1
            end
          elsif e.value == SDL::Joystick::HAT_RIGHTUP
            @@trigger_dir[3] = 1
            @@trigger_dir[2] = 1
            if @@pushed_dir_pre[3] == 0
              @@pushed_dir[3] = 1
              @@pushed_dir_pre[3] = 1
            end
            if @@pushed_dir_pre[2] == 0
              @@pushed_dir[2] = 1
              @@pushed_dir_pre[2] = 1
            end
          end
        when SDL::Event2::JoyButtonDown
          if e.button < @@trigger_btn.length
            @@trigger_btn[e.button] = 1
            if @@pushed_btn_pre[e.button] == 0
              @@pushed_btn[e.button] = 1
              @@pushed_btn_pre[e.button] = 1
            end
          end
        when SDL::Event2::JoyButtonUp
          if e.button < @@trigger_btn.length
            @@trigger_btn[e.button] = 0
            @@pushed_btn[e.button] = 0
            @@pushed_btn_pre[e.button] = 0
          end
        when SDL::Event2::Quit
          @@quit = true
        end
      end
    end
    
    def Input::triggerDir
      @@trigger_dir
    end
    
    def Input::pushedDir
      @@pushed_dir
    end
    
    def Input::triggerBtn
      @@trigger_btn
    end
    
    def Input::pushedBtn
      @@pushed_btn
    end
    
    def Input::triggerSpc?
      @@trigger_spc
    end
    
    def Input::triggerEnter?
      @@trigger_ent
    end
    
    def Input::triggerEscape?
      @@trigger_esc
    end
    
    def Input::pushedSpc?
      @@trigger_spc
    end
    
    def Input::pushedEnter?
      @@trigger_ent
    end
    
    def Input::pushedEscape?
      @@trigger_esc
    end
    
    def Input::quit?
      @@quit
    end
  end
  
=begin
=EGSR::AudioW[
==EGSR::Audio::BGMNX
BGMǗNX
t@Coggt@C̎gpB
mp3t@C͎gȂ
--- EGSR::Audio::BGM.new(fname, loops = true)
fnameŎw肵t@CBGMpɓo^B
loopśAt[v邩ǂtO
--- EGSR::Audio::BGM#setVolume(v)
BGM̉ʂݒ肷
--- EGSR::Audio::BGM#play
BGM̉tJn
܂ŉtĂBGM͒~
--- EGSR::Audio::BGM#fadeIn(msec=5000)
msecŎw肵~bŃtF[hCȂBGM̍ĐJn
--- EGSR::Audio::BGM#playing?
w̃IuWFNgBGMtĂ邩̃tO
--- EGSR::Audio::BGM#pause
݉tBGMꎞ~
--- EGSR::Audio::BGM#resume
t̋Ȃꎞ~ԂȂΉtĊJ
--- EGSR::Audio::BGM#stop
BGM̉t~
--- EGSR::Audio::BGM#fadeOut(msec = 5000, wmode = false)
msecŎw肵~bŃtF[hAEgȂBGM̍Đ~
wmodéAtF[hAEgĂԂ̓vO~邩tO
==EGSR::Audio::SENX
ʉǗNXB
t@Cwavet@Ĉ
--- EGSR::Audio::SE.new(fname)
fnameŎw肵t@Cʉpɓo^
--- EGSR::Audio::SE#play
IuWFNgǗʉt
--- EGSR::Audio::SE#stop
IuWFNgǗʉ̉t~
--- EGSR::Audio::SE#setVolume(v)
IuWFNgǗʉ̑傫vŎw肷
=end
  
  module Audio
    SDL::Mixer.open(192000, SDL::Mixer::DEFAULT_FORMAT, 2, 16384)
    class BGM
      def initialize(fname, loops = true)
        @bgm = SDL::Mixer::Music.load(fname)
        @loops = loops
      end
      
      def setVolume(v)
        SDL::Mixer.setVolumeMusic(v)
      end
      
      def play
        l = 0
        if @loops
          l = -1
        end
        SDL::Mixer.playMusic(@bgm, l).to_s()
      end
      
      def fadeIn(msec=5000)
        l = 0
        if @loops
          l = -1
        end
        SDL::Mixer.fadeInMusic(@bgm, l, msec)
      end
      
      def playing?
        SDL::Mixer.playMusic?
      end
      
      def pause
        if SDL::Mixer.playMusic?
          SDL::Mixer.pauseMusic
        end
      end
      
      def resume
        if SDL::Mixer.pauseMusic?
          SDL::Mixer.resumeMusic
        end
      end
      
      def stop
        if SDL::Mixer.playMusic?
          SDL::Mixer.haltMusic
        end
      end
      
      def fadeOut(msec = 5000, wmode = false)
        if SDL::Mixer.playMusic?
          SDL::Mixer.fadeOutMusic(msec)
          if wmode
            SDL::delay(msec)
          end
        end
      end
    end
    
    class SE
      def initialize(fname)
        @wave = SDL::Mixer::Wave.load(fname)
        @channel = -1
      end
      
      def play
        @channel = SDL::Mixer.playChannel(-1, @wave, 0)
      end
      
      def stop
        if @channel != -1
          SDL::Mixer.halt(@channel)
        end
      end
      
      def setVolume(v)
        @wave.setVolume(v)
      end
    end
  end

  def EGSR::update
    Input::update
    Screen::update
  end
  
=begin
=EGSR::SpriteNX
XvCgSʂǗNX
--- EGSR::Sprite.new()
SpriteNX̃IuWFNg쐬
AA`͍̈쐬Ȃ
`惁\bhǉŕ`̈ǉۂɎgp
--- EGSR::Sprite.create(w, h, px=0, py=0, alpha=255)
`̈쐬AƂɃXvCg쐬
wAhŐݒ肷
px,pygāAFƂĎw肷F݂rbg}bv̍Ww肷
ǂ炩-1̂Ƃ͓Fw肵Ȃ
alphagāA`掞̓xiAt@ufBOj0`255̊ԂŎw肷
0ƊSɓɂȂ
--- EGSR::Sprite.createFromBitmap(bmp, px=0, py=0, alpha=255)
EGSR::BitmapNX̃IuWFNgXvCg쐬
px,pygāAFƂĎw肷F݂rbg}bv̍Ww肷
ǂ炩-1̂Ƃ͓Fw肵Ȃ
alphagāA`掞̓xiAt@ufBOj0`255̊ԂŎw肷
0ƊSɓɂȂ
--- EGSR::Sprite.createFromBitmapAA(bmp)
EGSR::BitmapNX̃IuWFNgXvCg쐬
AcreateFromBitmapƂ̈Ⴂ́ABitmapIuWFNgA`GCAXɑΉĂ邱
čꂽIuWFNg͓Fⓧx͎włȂ
--- EGSR::Sprite.createPlane(bmp, w, h, px=0, py=0, alpha=255)
EGSR::BitmapNX̃IuWFNgv[`̃XvCg쐬
uv[`v́AqEGSR::PlaneNXQƂ̂
px,pygāAFƂĎw肷F݂rbg}bv̍Ww肷
ǂ炩-1̂Ƃ͓Fw肵Ȃ
alphagāA`掞̓xiAt@ufBOj0`255̊ԂŎw肷
0ƊSɓɂȂ
--- EGSR::Sprite.load(fname, px=0, py=0, alpha=255)
̉摜t@CXvCg쐬
px,pygāAFƂĎw肷F݂rbg}bv̍Ww肷
ǂ炩-1̂Ƃ͓Fw肵Ȃ
alphagāA`掞̓xiAt@ufBOj0`255̊ԂŎw肷
0ƊSɓɂȂ
--- EGSR::Sprite.loadAA(fname)
A`GCAX񂪊i[Ẳ摜t@CXvCg쐬
AloadƂ̈Ⴂ́ABitmapIuWFNgA`GCAXɑΉĂ邱
čꂽIuWFNg͓Fⓧx͎włȂ
--- EGSR::Sprite#Sprite.getList
܂łɓo^ĂXvCg̈ꗗԂ
EGSRŗpĂ

--- EGSR::Sprite#x
--- EGSR::Sprite#x=(v)
--- EGSR::Sprite#y
--- EGSR::Sprite#y=(v)
XvCg\ʏX,YW擾Eݒ肷
--- EGSR::Sprite#dp
--- EGSR::Sprite#dp=(v)
XvCg\ۂɏdˍ킹̊ƂȂ[x擾Eݒ肷
[x傫قǎOɕ\
[xXvCg݂Ƃ́Ao^ɕ`悳
--- EGSR::Sprite#w
--- EGSR::Sprite#h
XvCgɓo^Ă摜̕ƍ擾
--- EGSR::Sprite#ox
--- EGSR::Sprite#ox=(v)
--- EGSR::Sprite#oy
--- EGSR::Sprite#oy=(v)
XvCg摜ŁAʂɕ\̍X,YW擾Eݒ肷
--- EGSR::Sprite#ow
--- EGSR::Sprite#ow=(v)
--- EGSR::Sprite#oh
--- EGSR::Sprite#oh=(v)
XvCg摜ŁAʂɕ\̕ƍ擾Eݒ肷
--- EGSR::Sprite#visible
--- EGSR::Sprite#visible=(v)
XvCg\̉ۂtO擾Eݒ肷
--- EGSR::Sprite#angle
--- EGSR::Sprite#angle=(v)
XvCg]Ƃ̊px擾Eݒ肷
--- EGSR::Sprite#scaleX
--- EGSR::Sprite#scaleX=(v)
--- EGSR::Sprite#scaleY
--- EGSR::Sprite#scaleY=(v)
XvCggEkƂX,YW̔{擾Eݒ肷
--- EGSR::Sprite#centerX
--- EGSR::Sprite#centerX=(v)
--- EGSR::Sprite#centerY
--- EGSR::Sprite#centerY=(v)
XvCg]EgEkƂ̒SX,YW擾Eݒ肷
--- EGSR::Sprite#font
--- EGSR::Sprite#font=(v)
ʂɕ`悵Ƃ̃tHg(EGSR::FontNX̃CX^X)擾Eݒ肷
--- EGSR::Sprite#context
--- EGSR::Sprite#context=(v)
ʂɕ`悵Ƃ̕擾Eݒ肷
--- EGSR::Sprite#rcontext
--- EGSR::Sprite#rcontext=(v)
XvCg̈ɉʂɕ`悵Ƃɗ]擾Eݒ肷
EGSR::Screen.update\bhœIɌĂ΂
--- EGSR::Sprite#textMarginX
--- EGSR::Sprite#textMarginX=(v)
--- EGSR::Sprite#textMarginY
--- EGSR::Sprite#textMarginY=(v)
XvCg̈ɕ`悷ۂɎ}[W̕(X)A(Y)擾Eݒ肷
AEƂɓlgp
--- EGSR::Sprite#drawBlock
--- EGSR::Sprite#drawBlock=(v)
XvCgɕ`悳ۂ̃\bh̃ubN(ProcNX̃CX^X)擾Eݒ肷
--- EGSR::Sprite#alpha
--- EGSR::Sprite#alpha=(v)
XvCg𔼓ɂƂ̓x擾Eݒ肷
0̂Ƃ͊SɓɂȂA255̂Ƃ͊SɕsɂȂ
--- EGSR::Sprite#bitmap
XvCgŎgpĂ摜̈Ԃ
--- EGSR::Sprite#bitmap=(bmp)
XvCgŎgp摜̈o^
--- EGSR::Sprite#antiAlias?
XvCgIuWFNgA`GCAXgpĕ`悷邩ǂԂ
trueȂA`GCAXgp`IuWFNg
--- EGSR::Sprite#setCollisionMargin(x, y, w, h)
XvCgɃ^C铖蔻͈̔͂w肷
XvCg̍ォmx(XW),y(YW),w(͈͂̕),h(͈͂̍)n
ƂĐݒ肷
--- EGSR::Sprite#getCollisionMargin
uʏv̓蔻͈̔͂EGSR::RectNX̃IuWFNgƂĕԂ
--- EGSR::Sprite#viewPort
ʏ̃XvCg̕\͈͂EGSR::RectNX̃IuWFNgƂĕԂ
--- EGSR::Sprite#setViewPort(x, y, w, h)
ʏ̃XvCg̕\͈͂EGSR::RectNX̃IuWFNgƂēo^
--- EGSR::Sprite#rect
XvCg̕\TCYEGSR::RectNX̃IuWFNgƂĕԂ
--- EGSR::Sprite#update
EGSR::Screen.update\bhŎgpXvCgXVE`惁\bh
EGSR::Sprite#update=\bhProcNX̃IuWFNgnƂłA
update=\bhupdate\bhɃubN𒼐ړnƂoB
ubN̈̓XvCgIuWFNg{̂nB
--- EGSR::Sprite#update=(u)
update\bhŎsProcNX̃CX^XIuWFNgn
--- EGSR::Sprite#collision?(spr)
\bhsXvCgƈƂēnXvCgƂ
蔻肪ڐGĂƂtrueԂ
--- EGSR::Sprite#dispose
XvCg̈J
=end
  class Sprite
    extend Forwardable
    attr_accessor :x, :y, :ox, :oy, :visible, :angle, :centerX, :centerY
    attr_accessor :font, :context, :rcontext, :textMarginX, :textMarginY, :drawBlock
    attr_reader :ow, :oh
    attr_reader :dp, :id, :alpha, :scaleX, :scaleY
    @@sprites = SpriteList.new
    @@idcnt = 1

    def setup
      @img=nil
      @viewport = Rect.new(0, 0, Screen::Width, Screen::Height)
      @ow = 0
      @oh = 0
      @alpha = 255
      @aa = false
      @angle = 0
      @scaleX = 1.0
      @scaleY = 1.0
      @font = nil
      @context = ""
      @drawBlock = nil
      @update = nil
      @x = 0
      @y = 0
      @dp = 0
      @ox = 0
      @oy = 0
      @centerX = 0
      @centerY = 0
      @collisionX = 0
      @collisionY = 0
      @collisionW = 0
      @collisionH = 0
      @textMarginX = 0
      @textMarginY = 0
      @textMarginW = 0
      @textMarginH = 0
      @visible = false
    end
    
    private :setup

    def initialize()
      setup()
      @id = @@idcnt
      @@idcnt = @@idcnt + 1
      @@sprites.add(self)
    end
    
    def Sprite.create(w, h, px=0, py=0, alpha=255)
      spr = Sprite.new()
      img=Bitmap.create(w, h)
      if px != -1 || py != -1
        img.setColorKey(SDL::SRCCOLORKEY, img.getPixel(px, py))
      end
      spr.bitmap = img.displayFormat
      spr.alpha = alpha
      spr
    end
    
    def Sprite.createFromBitmap(bmp, px=0, py=0, alpha=255)
      spr = Sprite.new()
      if px != -1 || py != -1
        bmp.setColorKey(SDL::SRCCOLORKEY, bmp.getPixel(px, py))
      end
      spr.bitmap = bmp.displayFormat
      spr.alpha = alpha
      spr
    end
    
    def Sprite.createFromBitmapAA(bmp)
      spr = Sprite.new()
      spr.bitmap = bmp.displayFormatAlpha
      spr
    end
    
    def Sprite.createPlane(bmp, w, h, px=0, py=0, alpha=255)
      spr = Sprite.new()
      img=Bitmap.create(w, h)
      (h / bmp.h).times{|y|
        (w / bmp.w).times{|x|
          SDL.blitSurface(bmp, 0, 0, 0, 0, img, x * bmp.w, y * bmp.h)
        }
      }
      if px != -1 || py != -1
        img.setColorKey(SDL::SRCCOLORKEY, img.getPixel(px, py))
      end
      spr.bitmap = img.displayFormat
      spr.alpha = alpha
      spr.ow = Screen::screen.w
      spr.oh = Screen::screen.h
      spr
    end
    
    def Sprite.load(fname, px=0, py=0, alpha=255)
      spr = Sprite.new()
      img= Bitmap.load(fname)
      if px != -1 || py != -1
        img.setColorKey(SDL::SRCCOLORKEY, img.getPixel(px, py))
      end
      spr.bitmap = img.displayFormat
      spr
    end
    
    def Sprite.loadAA(fname)
      spr = Sprite.new()
      img= Bitmap.load(fname)
      spr.bitmap = img.displayFormatAlpha
      spr.antiAlias = true
      spr
    end
    
    def_delegators(:@img, :w, :h)
    
    def scaleX=(v)
      @scaleX = v.to_f()
    end
    
    def scaleY=(v)
      @scaleY = v.to_f()
    end
    
    def bitmap
      @img
    end
    
    def bitmap=(bmp)
      @img = bmp
      @ow = @img.w
      @oh = @img.h
      @w = @img.w
      @h = @img.h
      @collisionW = @ow
      @collisionH = @oh
    end
    
    def alpha=(val)
      if @aa == false
        @alpha = val
        @img.setAlpha(SDL::SRCALPHA, @alpha)
      end
    end
    
    def antiAlias=(f)
      @aa = f
    end
    
    def antiAlias?
      @aa
    end
    
    def dp=(val)
      odp = @dp
      @dp = val
      @@sprites.replaceDp(self, odp)
    end
    
    def ow=(v)
      @ow = v
      @collisionW = @ow
    end
    
    def oh=(v)
      @oh = v
      @collisionH = @oh
    end
    
    def setCollisionMargin(x, y, w, h)
      @collisionX = x
      @collisionY = y
      @collisionW = w
      @collisionH = h
    end
    
    def getCollisionMargin
      Rect.new(@x + @collisionX, @y + @collisionY, @collisionW, @collisionH)
    end
    
    def viewPort
      @viewport
    end
    
    def setViewPort(x, y, w, h)
      @viewport = Rect.new(x, y, w, h)
    end
    
    def rect
      Rect.new(@x, @y, @ow, @oh)
    end
    
    def update
      if @update != nil
        @update.call(self)
      end
      if block_given?
        yield self
      end
    end
    
    def update=(u)
      @update = u
    end
    
    def collision?(spr)
      r1 = getCollisionMargin
      r2 = spr.getCollisionMargin
      SDL::CollisionMap.boundingBoxCheck(r1.x, r1.y, r1.w, r1.h, r2.x, r2.y, r2.w, r2.h)
    end
    
    def dispose
      @@sprites.remove(self)
    end
    
    def Sprite::getList
      @@sprites.getList
    end
  end

=begin
=EGSR::PlaneNX
rbg}bvC[W~l߂悤ȕ\NX
x=\bhAy=\bhgp邱ƂŃXN[
--- EGSR::Plane.new(fname, px = 0, py = 0)
v[ǗCX^X쐬
fname̓v[쐬摜t@C
px,py͓FsNZ̍W
--- EGSR::Plane#x
--- EGSR::Plane#x=(v)
--- EGSR::Plane#y
--- EGSR::Plane#y=(v)
v[摜ŉʂ̍ɕ\ʒuXAYW̒l擾Eݒ肷
--- EGSR::Plane#drawBlock
--- EGSR::Plane#drawBlock=(b)
v[ɑ΂čs`施߂LqubN(ProcNX̃CX^X)擾Eݒ肷
--- EGSR::Plane#visible
--- EGSR::Plane#visible=(v)
v[\̉ۂtO擾Eݒ肷
--- EGSR::Plane#dp
--- EGSR::Plane#dp=(v)
v[\̐[xl擾Eݒ肷
--- EGSR::Plane#dispose
v[ɎgpĂXvCgIuWFNg
=end

  class Plane
    extend Forwardable
    def initialize(fname, px = 0, py = 0)
      @img = Bitmap.load(fname)
      @rw = ((Screen.w + @img.w) / @img.w + 1) * @img.w  # real width
      @rh = ((Screen.h + @img.h) / @img.h + 1) * @img.h  # real height
      @spr = Sprite.createPlane(@img, @rw, @rh, px, py, 255)
      @spr.dp = -1
      @x = 0
      @y = 0
    end
    
    def x
      @x
    end
    
    def x=(v)
      @x = v
      @spr.ox = @x % @img.w
    end
    
    def y
      @y
    end
    
    def y=(v)
      @y = v
      @spr.oy = @y % @img.h
    end
    
    def drawBlock
      @drawBlock
    end
    
    def drawBlock=(b)
      @drawBlock = b
    end
    
    def dispose
      @spr.dispose
    end
    
    def_delegators(:@spr, :visible, :visible=, :dp, :dp=)
  end

=begin
=EGSR::WindowParamNX
EBhEpɕ\鏑OtBbN͈̔͂i[NX
EBhȆgEwiɎgpep[c̗͈̈̔͂J[\p̃p[c̃Aj[Vp^[`
Aj[V\ȃJ[\p[c̗͈̈͂́Aۂɕ\p[c̑傫w肷邪AAj[V鑼̃p[c͂̉Ɋi[dlƂȂĂ
\̈
--- EGSR::WindowParam.new(lt, top, rt, left, right, lb, bottom, rb, client, wait, wp, cl, ct, cr, cb, cp, pl, pt, pr, pb, pp)
WindowParamNX̃CX^X𐶐
ep[^́Aȉlefttop`pagepat̐ɑΉĂ
--- EGSR::WindowParam.default
EGSRWŏĂWindowParamNX̃CX^XԂ
--- EGSR::WindowParam#lefttop
g̍ɕ`悷p[c̗̈EGSR::RectNX̃CX^X
--- EGSR::WindowParam#top
g̏ɕ`悷p[c̗̈EGSR::RectNX̃CX^X
--- EGSR::WindowParam#righttop
g̉Eɕ`悷p[c̗̈EGSR::RectNX̃CX^X
--- EGSR::WindowParam#left
g̍ɕ`悷p[c̗̈EGSR::RectNX̃CX^X
--- EGSR::WindowParam#right
g̉Eɕ`悷p[c̗̈EGSR::RectNX̃CX^X
--- EGSR::WindowParam#leftbottom
g̍ɕ`悷p[c̗̈EGSR::RectNX̃CX^X
--- EGSR::WindowParam#bottom
g̉ɕ`悷p[c̗̈EGSR::RectNX̃CX^X
--- EGSR::WindowParam#rightbottom
g̉Eɕ`悷p[c̗̈EGSR::RectNX̃CX^X
--- EGSR::WindowParam#client
wiƂĕ`悷p[c̗̈EGSR::RectNX̃CX^X
--- EGSR::WindowParam#wait
|[YJ[\Ƃĕ`悷p[c̗̈EGSR::RectNX̃CX^X
--- EGSR::WindowParam#waitpat
|[YJ[\̃Aj[Vp^[
--- EGSR::WindowParam#cursorleft
̑IJ[\Ƃĕ`悷p[c̗̈EGSR::RectNX̃CX^X(Aj[Vp^[P)
--- EGSR::WindowParam#cursortop
̑IJ[\Ƃĕ`悷p[c̗̈EGSR::RectNX̃CX^X(Aj[Vp^[P)
--- EGSR::WindowParam#cursorright
ȆIJ[\Ƃĕ`悷p[c̗̈EGSR::RectNX̃CX^X(Aj[Vp^[P)
--- EGSR::WindowParam#cursorbottom
̑IJ[\Ƃĕ`悷p[c̗̈EGSR::RectNX̃CX^X(Aj[Vp^[P)
--- EGSR::WindowParam#cursorpat
IJ[\̃Aj[Vp^[
--- EGSR::WindowParam#pageleft
̃y[WJ[\Ƃĕ`悷p[c̗̈EGSR::RectNX̃CX^X(Aj[Vp^[P)
--- EGSR::WindowParam#pagetop
̃y[WJ[\Ƃĕ`悷p[c̗̈EGSR::RectNX̃CX^X(Aj[Vp^[P)
--- EGSR::WindowParam#pageright
Ẽy[WJ[\Ƃĕ`悷p[c̗̈EGSR::RectNX̃CX^X(Aj[Vp^[P)
--- EGSR::WindowParam#pagebottom
̃y[WJ[\Ƃĕ`悷p[c̗̈EGSR::RectNX̃CX^X(Aj[Vp^[P)
--- EGSR::WindowParam#pagepat
y[WJ[\̃Aj[Vp^[
--- EGSR::WindowParam#w
g̈̕擾
AAep[c̕Ƃ̂ݗL
--- EGSR::WindowParam#h
g̈̍擾
AAep[c̍Ƃ̂ݗL
--- EGSR::WindowParam#ww
|[YJ[\̕Ԃ
--- EGSR::WindowParam#wh
|[YJ[\̍Ԃ
--- EGSR::WindowParam#cw
EBhE̍ォNCAg\̈̍܂ł̕Ԃ
AAep[c̕Ƃ̂ݗL
--- EGSR::WindowParam#ch
EBhE̍ォNCAg\̈̍܂ł̍Ԃ
AAep[c̍Ƃ̂ݗL
=end

  class WindowParam # structure class
    attr_reader :lefttop, :top, :righttop, :left
    attr_reader :right, :leftbottom, :bottom, :rightbottom
    attr_reader :client, :wait, :waitpat
    attr_reader :cursorleft, :cursortop, :cursorright, :cursorbottom, :cursorpat
    attr_reader :pageleft, :pagetop, :pageright, :pagebottom, :pagepat
    attr_reader :w, :h, :ww, :wh, :cw, :ch
    def initialize(lt, top, rt, left, right, lb, bottom, rb, client, wait, wp, cl, ct, cr, cb, cp, pl, pt, pr, pb, pp)
      @left, @right, @top, @bottom = [left, right, top, bottom]
      @lefttop, @righttop, @leftbottom, @rightbottom = [lt, rt, lb, rb]
      @client, @wait = [client, wait]
      @cursorleft, @cursortop, @cursorright, @cursorbottom = [cl, ct, cr, cb]
      @pageleft, @pagetop, @pageright, @pagebottom = [pl, pt, pr, pb]
      @waitpat, @cursorpat, @pagepat = [wp, cp, pp]
      @w = @left.w
      @h = @top.h
      @ww = @wait.w
      @wh = @wait.h
      @cw = @cursorleft.w
      @ch = @cursorleft.h
    end
    
    @@defParam = WindowParam.new(
      Rect.new(  0,  0, 32, 32),    # 
      Rect.new( 32,  0, 32, 32),    # 
      Rect.new( 64,  0, 32, 32),    # E
      Rect.new(  0, 32, 32, 32),    # 
      Rect.new( 64, 32, 32, 32),    # E
      Rect.new(  0, 64, 32, 32),    # 
      Rect.new( 32, 64, 32, 32),    # 
      Rect.new( 64, 64, 32, 32),    # E
      Rect.new( 96,  0,128,128),    # NCAg
      Rect.new(224,  0, 32, 32), 4, # EFCgAp^[
      Rect.new(  0,128, 32, 32),    # J[\E
      Rect.new( 32,128, 32, 32),    # J[\E
      Rect.new( 64,128, 32, 32),    # J[\EE
      Rect.new( 96,128, 32, 32), 4, # J[\EAp^[
      Rect.new(128,128, 32, 32),    # y[WJ[\E
      Rect.new(160,128, 32, 32),    # y[WJ[\E
      Rect.new(192,128, 32, 32),    # y[WJ[\EE
      Rect.new(224,128, 32, 32), 4  # y[WJ[\EAp^[
    )
    
    def WindowParam::default
      @@defParam
    end
  end

=begin
=EGSR::WindowNX
--- EGSR::Window#drawWindow
ۂɃEBhE`悷郁\bh
NXł́A
Eg摜
ENCAg̈
Ewi摜
̂R̃XvCgpӂĂ
gƔwi̓CX^Xɉ摜t@Cƃp[^XgiEGSR::WindowParamNX̃CX^XjƂɍ쐬
NCAg̈ɂ́A[U쐬rbg}bvAEBhEɕ\镶A`惁\bhi[

|[YJ[\́A̕\҂ۂɕ\J[\̂ƃL[̓͂܂ő҂ۂɎg
IJ[\́AR}hIȂǂɗpJ[\
y[WJ[\́ANCAg̈悪ۂ̗̈悩猩ė]ĂꍇɎIɕ\
y[W݂ĂR}hEBhEƂɎg

EGSR::updateŌĂ΂
--- EGSR::Window.new(fname, px = 0, py = 0, balpha = 255, cw = 128, ch = 128, istile = true, params = WindowParam::default)
EBhENX̃CX^X쐬
fname̓EBhȆgȂǂi[t@CApx,py͓F̃sNZ̍WAbalpha͔wi𓧉߂l(0`255)
cwAch̓NCAg\̈̃TCYAistitleɂ͔wi摜^Cɓ\邩gEkē\邩tOA
paramsɂ͈œn摜t@Cɑ΂AgEwiȂǂ̃p[^lEGSR::WindowParamsNX̃IuWFNgw肷
--- EGSR::Window.getList
\EBhEɑXvCg̈ꗗԂ
--- EGSR::Window#clientX
--- EGSR::Window#clientX=(v)
--- EGSR::Window#clientY
--- EGSR::Window#clientY=(v)
EBhEɑ΂NCAg̈̕\JnʒuX,YWԂ/ݒ肷
NCAg̈悪ۂ̕\̈͂ݏoĂꍇ̓y[WJ[\Iɕ\
--- EGSR::Window#clientW
--- EGSR::Window#clientH
--- EGSR::Window#clientSize
EBhẼNCAg\̈̕EԂ
clientSize\bh́A[w,h]̔zƂĕԂ
--- EGSR::Window#clientLeft
EBhE猩NCAg̈ւ̒Ԃ
ۂ́Ag̍̈̕Ɠ
--- EGSR::Window#clientTop
EBhE猩NCAg̈ւ̍Ԃ
ۂ́Ag̍̈̍Ɠ
--- EGSR::Window#setClient(img, px = 0, py = 0)
NCAg̈\邽߂̉摜o^
px,pyɂ͓FƂȂsNZ̍Wn
--- EGSR::Window#pauseWait
--- EGSR::Window#pauseWait=(v)
EBhẼ|[Y摜\ƂɁAAj[VƂ̃t[擾Eݒ肷
--- EGSR::Window#cursorVisible
--- EGSR::Window#cursorVisible=(v)
EBhȆIJ[\\̉ۂtO擾Eݒ肷
--- EGSR::Window#cursorWait
--- EGSR::Window#cursorWait=(v)
IJ[\̃Aj[Vsۂ̃t[擾Eݒ肷
--- EGSR::Window#cursorDir
--- EGSR::Window#cursorDir=(v)
IJ[\\Ƃ̕擾Eݒ肷
EEEȄŒl0`3ɂȂ
--- EGSR::Window#cursorX
--- EGSR::Window#cursorX=(v)
--- EGSR::Window#cursorY
--- EGSR::Window#cursorY=(v)
IJ[\\ۂ̃NCAg̈X,YW擾Eݒ肷
--- EGSR::Window#pageWait
--- EGSR::Window#pageWait=(v)
y[WJ[\̃Aj[Vsۂ̃t[擾Eݒ肷
--- EGSR::Window#pause?
--- EGSR::Window#pause=(v)
`̃|[Ysǂ̃tO擾Eݒ肷
--- EGSR::Window#x
--- EGSR::Window#x=(v)
--- EGSR::Window#y
--- EGSR::Window#y=(v)
EBhE\ʏX,YW擾Eݒ肷
--- EGSR::Window#dp
--- EGSR::Window#dp=(v)
--- EGSR::Window#setDPs(*v)
EBhE\[x擾Eݒ肷
setDPs\bh͔wiENCAgEgꂼ̐[xݒ肷
dp=\bhł͊eXvCg̐[x͓lɂȂ
dp\bhł[g,NCAg,wi]̊e[xԂ
--- EGSR::Window#visible
--- EGSR::Window#visible=(f)
EBhE\̉ۂtO擾Eݒ肷
--- EGSR::Window#bgAlpha
--- EGSR::Window#bgAlpha=(v)
EBhE̔wïɑ΂铧x擾Eݒ肷
--- EGSR::Window#context
--- EGSR::Window#context=(c)
EBhEɕ`悷镶擾Eݒ肷
܂AFontNXŐ}Ngpł
--- EGSR::Window#rcontext
--- EGSR::Window#rcontext=(c)
EBhEɕ`悵ۂɁANCAg̈悩͂ݏo擾Eݒ肷
--- EGSR::Window#font
--- EGSR::Window#font=(f)
EBhEɕ`悷ۂɎgtHg(EGSR::FontNX̃CX^X)擾Eݒ肷
--- EGSR::Window#drawBlock
--- EGSR::Window#drawBlock=(b)
EBhEɕ`悷閽߂̃ubN(ProcNX̃CX^X)擾Eݒ肷
--- EGSR::Window#dispose
EBhEɎgeXvCg摜̈J
=end

  class Window
    extend Forwardable
    @@windows = Array.new
    
    def drawWindow
      @client.bitmap.fillRect(0, 0, @window.w, @window.h, @ccol)
      @window.bitmap.fillRect(0, 0, @window.w, @window.h, @bcol)
      if @clientimg != nil
        SDL.blitSurface2(@clientimg, [@cx, @cy, @cw, @ch], @client.bitmap, [@params.lefttop.w, @params.lefttop.h, @cw, @ch])
      end
      if @waiting && @waitwait != 0
        if @waitcnt == 0
          @waitpat = (@waitpat + 1) % @params.waitpat
          @waitcnt = @waitwait
        else
          @waitcnt = @waitcnt - 1
        end
        SDL.blitSurface(@wImg, 0, @params.wait.h * @waitpat, @params.wait.w, @params.wait.h, @window.bitmap, @params.lefttop.w + (@cw - @params.wait.w) / 2, @params.lefttop.h + @ch - @params.wait.h)
      else
        if @pagecnt == 0
          @pagepat = (@pagepat + 1) % @params.pagepat
          @pagecnt = @pagewait
        else
          @pagecnt = @pagecnt - 1
        end
        if @clientimg != nil
          if @clientimg.w > (@cx + @cw)
            SDL.blitSurface(@prImg, 0, @params.pageright.h * @pagepat, @params.pageright.w, @params.pageright.h, @window.bitmap, @params.lefttop.w + @cw - @params.pageright.w, @params.lefttop.h + (@ch - @params.pageright.h) / 2)
          end
          if @cx > 0
            SDL.blitSurface(@plImg, 0, @params.pageleft.h * @pagepat, @params.pageleft.w, @params.pageleft.h, @window.bitmap, @params.lefttop.w, @params.lefttop.h + (@ch - @params.pageleft.h) / 2)
          end
          if @clientimg.h > (@cy + @ch)
            SDL.blitSurface(@pbImg, 0, @params.pagebottom.h * @pagepat, @params.pagebottom.w, @params.pagebottom.h, @window.bitmap, @params.lefttop.w + (@cw - @params.pagebottom.w) / 2, @params.lefttop.h + @ch - @params.pagebottom.h)
          end
          if @cy > 0
            SDL.blitSurface(@ptImg, 0, @params.pagetop.h * @pagepat, @params.pagetop.w, @params.pagetop.h, @window.bitmap, @params.lefttop.w + (@cw - @params.pagetop.w) / 2, @params.lefttop.h)
          end
        end
        if @cursorvisible
          if @cursorcnt == 0
            @cursorpat = (@cursorpat + 1) % @params.cursorpat
            @cursorcnt = @cursorwait
          else
            @cursorcnt = @cursorcnt - 1
          end
          rect = if @cursordir == 0
                   @params.cursorleft
                 elsif @cursordir == 1
                   @params.cursortop
                 elsif @cursordir == 2
                   @params.cursorright
                 elsif @cursordir == 3
                   @params.cursorbottom
                 else
                   nil
                 end
          img  = if @cursordir == 0
                   @plImg
                 elsif @cursordir == 1
                   @ptImg
                 elsif @cursordir == 2
                   @prImg
                 elsif @cursordir == 3
                   @pbImg
                 else
                   nil
                 end
          SDL.blitSurface(img, 0, rect.h * @cursorpat, rect.w, rect.h, @window.bitmap, @params.lefttop.w + @cursorx, @params.lefttop.h + @cursory)
        end
      end
      SDL.blitSurface(@top, 0, 0, 0, 0, @window.bitmap, 0, 0)
    end
    
    def copyRect(bmp, x, y, w, h)
      src = bmp.copyRect(x, y, w, h)
      src.setColorKey(SDL::SRCCOLORKEY, @bcol)
      src.displayFormat
    end
    
    private :copyRect
    
    def initialize(fname, px = 0, py = 0, balpha = 255, cw = 128, ch = 128, istile = true, params = WindowParam::default)
      @base = Bitmap.load(fname)
      @bcol = @base.getPixel(px, py)
      @balpha = balpha
      @params = params
      @isTile = istile
      @cw = cw
      @ch = ch
      @cx = 0
      @cy = 0
      @waiting = false
      @waitvisible = false
      @waitwait = 0
      @waitcnt = @waitwait
      @waitpat = 0
      @cursorvisible = false
      @cursorwait = 0
      @cursorcnt = @cursorwait
      @cursorpat = 0
      @cursordir = 2
      @cursorx = 0
      @cursory = 0
      @pagewait = 0
      @pagecnt = @pagewait
      @pagepat = 0
      @clientimg = nil
      @ccol = Color.rgb2cc(0, 0, 0)

      src = Bitmap.create(@params.client.w, @params.client.h)
      src.setColorKey(SDL::SRCCOLORKEY, @bcol)
      SDL.blitSurface(@base, @params.client.x, @params.client.y, @params.client.w, @params.client.h, src, 0, 0)

      @back=Sprite.create(cw+@params.w*2, ch+@params.h*2, 0, 0, @balpha)
      @back.bitmap.setColorKey(SDL::SRCCOLORKEY, @bcol)

      @back.bitmap.fillRect(0, 0, @back.w, @back.h, @bcol)
      if @isTile
        tx = @cw / src.w
        mx = @cw % src.w
        ty = @ch / src.h
        my = @ch % src.h
        ty.times{|t1|
          tx.times{|t2|
            SDL.blitSurface(src, 0, 0, 0, 0, @back.bitmap, @params.lefttop.w + t2 * src.w, @params.lefttop.h + t1 * src.h)
          }
          if mx > 0
            SDL.blitSurface(src, 0, 0, mx, src.h, @back.bitmap, @params.lefttop.w + tx * src.w, 0)
          end
        }
        if my > 0
          tx.times{|t2|
            SDL.blitSurface(src, 0, 0, src.h, my, @back.bitmap, @params.lefttop.w + t2 * src.w, @params.lefttop.h + ty * src.h)
          }
        end
        if mx > 0 && my > 0
          SDL.blitSurface(src, 0, 0, mx, my, @back.bitmap, @params.lefttop.w + tx * src.w, @params.lefttop.h + ty * src.h)
        end
      else
        SDL.transform(src, @back.bitmap, 0, @back.w / src.w + 2, @back.h / src.h + 2, 0, 0, 0, 0, SDL::TRANSFORM_AA) # why + 2 ???
        @back.bitmap.fillRect(0, 0, @params.lefttop.w, @back.h, @bcol)
        @back.bitmap.fillRect(@params.lefttop.w + @cw, 0, @params.righttop.w, @back.h, @bcol)
        @back.bitmap.fillRect(0, 0, @back.w, @params.lefttop.h, @bcol)
        @back.bitmap.fillRect(0, @params.lefttop.h + @ch, @back.w, @params.leftbottom.h, @bcol)
      end
      @back.bitmap = @back.bitmap.displayFormat
      
      src1 = copyRect(@base, @params.top.x, @params.top.y, @params.top.w, @params.top.h)
      src2 = copyRect(@base, @params.left.x, @params.left.y, @params.left.w, @params.left.h)
      src3 = copyRect(@base, @params.right.x, @params.right.y, @params.right.w, @params.right.h)
      src4 = copyRect(@base, @params.bottom.x, @params.bottom.y, @params.bottom.w, @params.bottom.h)
      src5 = copyRect(@base, @params.lefttop.x, @params.lefttop.y, @params.lefttop.w, @params.lefttop.h)
      src6 = copyRect(@base, @params.righttop.x, @params.righttop.y, @params.righttop.w, @params.righttop.h)
      src7 = copyRect(@base, @params.leftbottom.x, @params.leftbottom.y, @params.leftbottom.w, @params.leftbottom.h)
      src8 = copyRect(@base, @params.rightbottom.x, @params.rightbottom.y, @params.rightbottom.w, @params.rightbottom.h)

      @top = Bitmap.create(@cw+@params.left.w+@params.right.w, @ch+@params.top.h+@params.bottom.h)
      @top.setColorKey(SDL::SRCCOLORKEY, @bcol)
      @top.fillRect(0, 0, @top.w, @top.h, @bcol)

      SDL.blitSurface(src5, 0, 0, 0, 0, @top, 0, 0)
      SDL.blitSurface(src6, 0, 0, 0, 0, @top, @params.lefttop.w+@cw, 0)
      SDL.blitSurface(src7, 0, 0, 0, 0, @top, 0, @params.lefttop.h+@ch)
      SDL.blitSurface(src8, 0, 0, 0, 0, @top, @params.lefttop.w+@cw, @params.lefttop.h+@ch)
      tx = @cw / src1.w
      mx = @cw % src1.w
      tx.times{|t|
        SDL.blitSurface(src1, 0, 0, 0, 0, @top, @params.lefttop.w + t * src1.w, 0)
      }
      if mx > 0
        SDL.blitSurface(src1, 0, 0, mx, src1.h, @top, @params.lefttop.w + tx * src1.w, 0)
      end
      tx = @ch / src2.h
      mx = @ch % src2.h
      tx.times{|t|
        SDL.blitSurface(src2, 0, 0, 0, 0, @top, 0, @params.lefttop.h + t * src2.h)
      }
      if mx > 0
        SDL.blitSurface(src2, 0, 0, src2.w, mx, @top, 0, @params.lefttop.h + tx * src2.h)
      end
      tx = @ch / src3.h
      mx = @ch % src2.h
      tx.times{|t|
        SDL.blitSurface(src3, 0, 0, 0, 0, @top, @params.lefttop.w + @cw, @params.lefttop.h + t * src2.h)
      }
      if mx > 0
        SDL.blitSurface(src3, 0, 0, src3.w, mx, @top, @params.lefttop.w + @cw, @params.lefttop.h + tx * src3.h)
      end
      tx = @cw / src4.w
      mx = @cw % src1.w
      tx.times{|t|
        SDL.blitSurface(src4, 0, 0, 0, 0, @top, @params.lefttop.w + t * src4.w, @params.lefttop.h + @ch)
      }
      if mx > 0
        SDL.blitSurface(src4, 0, 0, mx, src4.h, @top, @params.lefttop.w + tx * src4.w, @params.lefttop.h + @ch)
      end

      @wImg = copyRect(@base, @params.wait.x, @params.wait.y, @params.wait.w, @params.wait.h * @params.waitpat)
      @clImg = copyRect(@base, @params.cursorleft.x, @params.cursorleft.y, @params.cursorleft.w, @params.cursorleft.h * @params.cursorpat)
      @ctImg = copyRect(@base, @params.cursortop.x, @params.cursortop.y, @params.cursortop.w, @params.cursortop.h * @params.cursorpat)
      @crImg = copyRect(@base, @params.cursorright.x, @params.cursorright.y, @params.cursorright.w, @params.cursorright.h * @params.cursorpat)
      @cbImg = copyRect(@base, @params.cursorbottom.x, @params.cursorbottom.y, @params.cursorbottom.w, @params.cursorbottom.h * @params.cursorpat)
      @plImg = copyRect(@base, @params.pageleft.x, @params.pageleft.y, @params.pageleft.w, @params.pageleft.h * @params.pagepat)
      @ptImg = copyRect(@base, @params.pagetop.x, @params.pagetop.y, @params.pagetop.w, @params.pagetop.h * @params.pagepat)
      @prImg = copyRect(@base, @params.pageright.x, @params.pageright.y, @params.pageright.w, @params.pageright.h * @params.pagepat)
      @pbImg = copyRect(@base, @params.pagebottom.x, @params.pagebottom.y, @params.pagebottom.w, @params.pagebottom.h * @params.pagepat)

      @client=Sprite.create(cw, ch, -1, -1, 255)
      @client.bitmap.setColorKey(SDL::SRCCOLORKEY, @ccol)
      @client.bitmap.fillRect(0, 0, @client.w, @client.h, @ccol)
      @client.bitmap = @client.bitmap.displayFormat
      @client.textMarginX = @params.lefttop.w
      @client.textMarginY = @params.lefttop.h

      @window=Sprite.create(cw+@params.w*2, ch+@params.h*2, -1, -1, 255)
      @window.bitmap.setColorKey(SDL::SRCCOLORKEY, @bcol)

      drawWindow()
      @x = 0
      @y = 0
      @cx = 0
      @cy = 0
      @dp = 0

      @@windows.push(self)
    end
    
    def clientX
      @cx
    end
    
    def clientX=(v)
      @cx = v
    end
    
    def clientY
      @cy
    end
    
    def clientY=(v)
      @cy = v
    end
    
    def clientW
      @cw
    end
    
    def clientH
      @ch
    end
    
    def clientSize
      [@cw, @ch]
    end
    
    def clientLeft
      @params.lefttop.w
    end
    
    def clientTop
      @params.lefttop.h
    end
    
    def setClient(img, px = 0, py = 0)
      @clientimg=img
      if px != -1 && py != -1
        @ccol = @clientimg.getPixel(px, py)
        @client.bitmap.setColorKey(SDL::SRCCOLORKEY, @ccol)
        @client.bitmap.fillRect(0, 0, @client.w, @client.h, @ccol)
      end
      drawWindow()
    end
    
    def pauseWait
      @waitwait
    end
    
    def pauseWait=(v)
      @waitwait = v
      @waitcnt = @waitwait
      if @waiting == true
        @waitvisible = true
      end
    end
    
    def cursorVisible
      @cursorvisible
    end
    
    def cursorVisible=(v)
      @cursorvisible = v
    end
    
    def cursorWait
      @cursorwait
    end
    
    def cursorWait=(v)
      @cursorwait = v
      @cursorcnt = @cursorwait
    end
    
    def cursorDir
      @cursordir
    end
    
    def cursorDir=(v)
      @cursordir = v
    end
    
    def cursorX
      @cursorx
    end
    
    def cursorX=(v)
      @cursorx = v
    end
    
    def cursorY
      @cursory
    end
    
    def cursorY=(v)
      @cursory = v
    end
    
    def pageWait
      @pagewait
    end
    
    def pageWait=(v)
      @pagewait = v
      @pagecnt = @cursorwait
    end
    
    def pause=(v)
      @waiting = v
      if @waiting == false
        @client.context = @client.rcontext
      end
    end
    
    def pause?
      @waiting
    end
    
    def x=(v)
      @back.x = v
      @client.x = v
      @window.x = v
    end
    
    def y=(v)
      @back.y = v
      @client.y = v
      @window.y = v
    end
    
    def dp
      [@window.dp, @client.dp, @back.dp]
    end
    
    def dp=(v)
      @back.dp = v
      @client.dp = v
      @window.dp = v
    end
    
    def setDPs(*v)
      @back.dp = v[0]
      @client.dp = v[1] if v.length > 1
      @window.dp = v[2] if v.length > 2
    end
    
    def visible=(f)
      @back.visible = f
      @client.visible = f
      @window.visible = f
    end
    
    def bgAlpha
      @balpha
    end
    
    def bgAlpha=(v)
      @balpha = b
      @back.alpha = @balpha
    end
    
    def context
      @client.context
    end
    
    def context=(c)
      @client.context = c
    end
    
    def rcontext
      @client.rcontext
    end
    
    def rcontext=(c)
      @client.rcontext = c
    end
    
    def font
      @client.font
    end
    
    def font=(f)
      @client.font = f
    end
    
    def drawBlock
      @client.drawBlock
    end
    
    def drawBlock=(b)
      @client.drawBlock = b
    end
    
    def dispose
      @back.dispose
      @back = nil
      @client.dispose
      @client = nil
      @top = nil
      @clientimg = nil
      @params = nil
      @base = nil
      @@windows.delete(self)
    end
    
    def Window::getList
      @@windows
    end
    
    def_delegators(:@window, :visible, :x, :y)
    
  end

=begin
=EGSR::MapNX
=EGSR::MapFastNX
̃}bv`bvƃ}bvf[^Ƀ}bv摜쐬NX
x=\bhAy=\bhgpă}bvXN[邱Ƃł
}bvɂ͊eC݂ĂÃCʁX̐[xŏdˍ킹邱Ƃo
ȂAŌ̃CiԎOɕ\͂̃Cj́uCxgCvƌĂсAۂɂ͉摜͍炸ɊeCxgN߂̃R[hio[i[郌CƂċ@\
(AAC1݂̂̂Ƃ̓}bv̕`s)
MaṕAʂ̍XVɃ}bv\ă̎gp}Ă邪AȂXN[xȂ
MapFast́A}bv̉摜Sĕ`悵āÄꕔ\Ă邽߁A`͑ʂȂ傫Ȃ
Map,MapFastNX̊e\bh͋ʂ̂߁AMapNX̂̂\ɐ

ȂA}bvɎgpR[hio[ƃ}bv`bv摜Ƃ̊֘ÁAuPlatinumvƂt[Windowsp}bvGfB^̌`̗pĂ

=EGSR::MapLayerNX
=EGSR::MapLayerFastNX
ۂ̃}bvf[^ƕ\摜(C)NX
̃NX́AۂEGSR::Map/MapFastNXŎgpĂ邽ߐ͊

--- EGSR::Map.new(name, tsize, tpixels, px, py, loopx, loopy, mname, *blist)
}bvi[CX^X𐶐
nameɂ́A}bv`bvݒ肷
tsize̓}bv`bṽR[hio[̒Pʂ(16256AW256)
tsize̒ĺA}bv`bv̑傫Ɉ˂Ȃ
tsize16̂Ƃ0`255A256̂Ƃ0`65535R[hio[ɂȂ
tpixels̓}bv`bvP̃sNZ
Ɏw͖A16sNZ32sNZƂȂ
px,pýA}bv`bv摜œFƂȂsNZX,YW
loopx,loopýAXAYɃ}bv𖳌XN[邩tO
falsȅꍇA}bve[ɓBƃXN[~܂
mnaméA}bvɕ\R[hio[߂csvt@Cw肷
̂ƂAcsvt@Cɑ݂郌C̓CxgCԐ擪ɂȂ邱Ƃɒӂ邱
blistɂ́AeCɕ\}bv`bvt@Cw肷
--- EGSR::Map#name
CX^XɊ܂܂}bvԂ
--- EGSR::Map#layers
--- EGSR::Map#layer(idx)
--- EGSR::Map#lastLayer
layers\bh́ACX^XɊi[Ă郌C̈ꗗԂ
layer\bh́A\ɎOidxԖڂ̃C擾(CxgC܂)
lastLayerhbh́ACxgC擾
--- EGSR::Map#x
--- EGSR::Map#x=(v)
--- EGSR::Map#y
--- EGSR::Map#y=(v)
}bvʂɕ\ۂ̍X,YW擾Eݒ肷
--- EGSR::Map#w
--- EGSR::Map#h
}bv摜̕E擾
AAsNZPʂł͂Ȃ}bv`bvPʂƂȂ
--- EGSR::Map#dp
--- EGSR::Map#dp=(d)
--- EGSR::Map#setDPs(*dl)
eC̐[x擾Eݒ肷
dp\bh́AeC̐[xz`ŕԂ
dp=\bh́AeC̐[x𓯈lŐݒ肷
setDPs\bh́AeC̐[xʁXɎw肷
--- EGSR::Map#visible
--- EGSR::Map#visible=(f)
}bv\Ă邩tO擾Eݒ肷
--- EGSR::Map#getCode(x, y)
}bv`bv̍WΉ}bv`bvR[h擾
Cxg̗L𔻕ʂ邷ۂɎgp
--- EGSR::Map#dispose
}bv邳ɎgpXvCg̈J
=end


  class Map
    class MapLayer
      extend Forwardable
      attr_reader :x, :y, :w, :h
      UnRollingX = 4
      UnRollingY = 2

      def copyRect(bmp, x, y, w, h)
        src = bmp.copyRect(x, y, w, h)
        src.setColorKey(SDL::SRCCOLORKEY, @bcol)
        src.displayFormat
      end
    
      private :copyRect
    
      def initialize(tsize, tpixels, px, py, mapdat, w, h, baseimg)
        @tsize = tsize
        @tpixels = tpixels
        @px = px
        @py = py
        @x = 0
        @cx = 0
        @mx = 0
        @y = 0
        @cy = 0
        @my = 0
        @mapdat = mapdat
        @baseimg = Bitmap.load(baseimg)
        @w = w
        @h = h
        @cw = Screen::Width / @tpixels + 1
        @ch = Screen::Height / @tpixels + 1
        @ucw = @cw / UnRollingX + 1
        @uch = @ch / UnRollingY + 1
        @bcol = 0 # black
        @spr = Sprite.create(Screen::Width, Screen::Height, -1, -1, 255)
        @chipdb = Hash.new()
        (@baseimg.h / @tpixels).times{|y|
          (@baseimg.w / @tpixels).times{|x|
            @chipdb[y * @tsize + x] = copyRect(@baseimg, @tpixels * x, @tpixels * y, @tpixels, @tpixels)
          }
        }
        @buf = Bitmap.create(Screen::Width + @tpixels, Screen::Height + @tpixels)
        if @px != -1 && @py != -1
          @bcol = @baseimg.getPixel(@px, @py)
          @spr.bitmap.setColorKey(SDL::SRCCOLORKEY, @bcol)
        end
        @spr.update = Proc.new{|o|
          @buf.fillRect(0, 0, @buf.w, @buf.h, @bcol)
          yp = 0
          v2 = @cy
          ycnt = 0
          while ycnt < @uch do
            v = @cx
            tv = 0
            wh = v2 % @w * @h
            @ucw.times{|x|
              code = @mapdat[wh + v % @h]
              if @chipdb[code] != nil
                SDL.blitSurface(@chipdb[code], 0, 0, 0, 0, @buf, tv, yp)
              end
              v = v + 1
              tv = tv + @tpixels
              code = @mapdat[wh + v % @h]
              if @chipdb[code] != nil
                SDL.blitSurface(@chipdb[code], 0, 0, 0, 0, @buf, tv, yp)
              end
              v = v + 1
              tv = tv + @tpixels
              code = @mapdat[wh + v % @h]
              if @chipdb[code] != nil
                SDL.blitSurface(@chipdb[code], 0, 0, 0, 0, @buf, tv, yp)
              end
              v = v + 1
              tv = tv + @tpixels
              code = @mapdat[wh + v % @h]
              if @chipdb[code] != nil
                SDL.blitSurface(@chipdb[code], 0, 0, 0, 0, @buf, tv, yp)
              end
              v = v + 1
              tv = tv + @tpixels
            }
            v2 = v2 + 1
            yp = yp + @tpixels
            
            v = @cx
            tv = 0
            wh = v2 % @w * @h
            @ucw.times{|x|
              code = @mapdat[wh + v % @h]
              if @chipdb[code] != nil
                SDL.blitSurface(@chipdb[code], 0, 0, 0, 0, @buf, tv, yp)
              end
              v = v + 1
              tv = tv + @tpixels
              code = @mapdat[wh + v % @h]
              if @chipdb[code] != nil
                SDL.blitSurface(@chipdb[code], 0, 0, 0, 0, @buf, tv, yp)
              end
              v = v + 1
              tv = tv + @tpixels
              code = @mapdat[wh + v % @h]
              if @chipdb[code] != nil
                SDL.blitSurface(@chipdb[code], 0, 0, 0, 0, @buf, tv, yp)
              end
              v = v + 1
              tv = tv + @tpixels
              code = @mapdat[wh + v % @h]
              if @chipdb[code] != nil
                SDL.blitSurface(@chipdb[code], 0, 0, 0, 0, @buf, tv, yp)
              end
              v = v + 1
              tv = tv + @tpixels
            }
            v2 = v2 + 1
            yp = yp + @tpixels
            ycnt = ycnt + 1
          end
          SDL.blitSurface(@buf, 0, 0, 0, 0, o.bitmap, -@mx, -@my)
        }
      end
      
      def getCode(x, y)
        @mapdat[y / @tpixels][x / @tpixels]
      end
      
      def x=(v)
        @x = v
        @cx = @x / @tpixels
        @mx = @x % @tpixels
      end
      
      def y=(v)
        @y = v
        @cy = @y / @tpixels
        @my = @y % @tpixels
      end
      
      def dispose
        @spr.dispose
      end
      
      def_delegators(:@spr, :visible, :visible=, :dp, :dp=)
    end

    attr_reader :name, :layers, :x, :y, :w, :h
    
    def initialize(name, tsize, tpixels, px, py, loopx, loopy, mname, *blist)
      @name = name
      @layers = Array.new()
      @tsize = tsize
      @tpixels = tpixels
      @loopX = loopx
      @loopY = loopy
      @x = 0
      @y = 0
      
      h = 0
      llist = Array.new()
      File.open(mname, "r"){|f|
        mlist = Array.new()
        while !(f.eof?()) do
          l = f.readline()
          if l =~ /^[\r\n]+$/
            llist.push(mlist)
            mlist = Array.new()
            next
          end
          mlist.concat(l.split(",").collect{|v| v.to_i()})
          if h == 0
            h = mlist.length
          end
        end
        if mlist.length != 0
          llist.push(mlist)
        end
      }
      
      w = llist[0].length / h
      
      llist.length.times{|c|
        @layers.push(MapLayer.new(@tsize, @tpixels, px, py, llist[c], w, h, blist[llist.length - 1 - c]))
      }
      
      @w = @layers[0].w
      @h = @layers[0].h
    end
    
    def x=(v)
      if @loopX == false
        if @w * @tpixels - v <= Screen::Width
          return
        end
        @x = v
        if @x < 0
          @x = 0
        end
      else
        @x = v
        if @w * @tpixels - @x <= Screen::Width
          @x = @x % (@w * @tpixels)
        elsif @x < 0
          @x = @w * @tpixels + @x
        end
      end
      @layers.each{|l|
        l.x = @x
      }
    end
    
    def y=(v)
      if @loopY == false
        if @h * @tpixels - v <= Screen::Height
          return
        end
        @y = v
        if @y < 0
          @y = 0
        end
      else
        @y = v
        if @h * @tpixels - @y <= Screen::Height
          @y = @y % (@h * @tpixels)
        elsif @y < 0
          @y = @h * @tpixels + @y
        end
      end
      @layers.each{|l|
        l.y = @y
      }
    end
    
    def dp
       @layers.collect{|l| l.dp }
    end
    
    def dp=(d)
      @layers.each{|l|
        l.dp = d
      }
    end
    
    def setDPs(*dl)
      l = dl.length
      l = @layers.length if l > @layers.length
      l.length.times{|d|
        @layers[d].dp = dl[d]
      }
    end
    
    def layer(idx)
      @layers[idx]
    end
    
    def lastLayer
      @layers[@layers.length - 1]
    end
    
    def visible
      @layers[0].visible
    end
    
    def visible=(f)
      if @layers.length == 1
        @layers[0].visible = true
        return
      end
      @layers.each{|ll|
        ll.visible = f
      }
      lastLayer.visible = false
    end
    
    def getCode(x, y)
      lastLayer.getCode(x, y)
    end
    
    def dispose
      @layers.each{|l|
        l.dispose
        l = nil
      }
      @layers = Array.new
    end
  end
  
  class MapFast
    class MapLayerFast
      extend Forwardable
      attr_reader :w, :h
      def initialize(tsize, tpixels, px, py, mapdat, baseimg, drawable)
        @tsize = tsize
        @tpixels = tpixels
        @px = px
        @py = py
        @mapdat = mapdat
        @baseimg = Bitmap.load(baseimg)
        @w = @mapdat[0].length
        @h = @mapdat.length
        @marginX = Screen::Width
        @marginY = Screen::Height
        if drawable == false
          @spr = Sprite.new()
          return
        end
        @spr = Sprite.create(@w * tpixels + @marginX, @h * tpixels + @marginY, -1, -1, 255)
        if @px != -1 && @py != -1
          @spr.bitmap.setColorKey(SDL::SRCCOLORKEY, @baseimg.getPixel(@px, @py))
          @spr.bitmap.fillRect(0, 0, @spr.bitmap.w, @spr.bitmap.h, @baseimg.getPixel(@px, @py))
        end
        (@h + @marginY / @tpixels + 1).times{|y|
          (@w + @marginX / @tpixels + 1).times{|x|
            SDL.blitSurface(@baseimg, @tpixels * (@mapdat[y % @h][x % @w] % @tsize), @tpixels * (@mapdat[y % @h][x % @w] / @tsize), @tpixels, @tpixels, @spr.bitmap, @tpixels * x, @tpixels * y)
          }
        }
        @spr.bitmap = @spr.bitmap.displayFormat
      end
      
      def getCode(x, y)
        @mapdat[y / @tpixels][x / @tpixels]
      end
      
      def_delegator(:@spr, :ox,  :x)
      def_delegator(:@spr, :ox=, :x=)
      def_delegator(:@spr, :oy,  :y)
      def_delegator(:@spr, :oy=, :y=)
      def_delegators(:@spr, :visible, :visible=, :dp, :dp=)

      def dispose
        @spr.dispose
      end
    end

    attr_reader :name, :layers, :x, :y, :w, :h
    
    def initialize(name, tsize, tpixels, px, py, loopx, loopy, mname, *blist)
      @name = name
      @layers = Array.new()
      @tsize = tsize
      @tpixels = tpixels
      @loopX = loopx
      @loopY = loopy
      @x = 0
      @y = 0
      
      llist = Array.new()
      File.open(mname, "r"){|f|
        mlist = Array.new()
        while !(f.eof?()) do
          l = f.readline()
          if l =~ /^[\r\n]+$/
            llist.push(mlist)
            mlist = Array.new()
            next
          end
          mlist.push(l.split(",").collect{|v| v.to_i()})
        end
        if mlist.length != 0
          llist.push(mlist)
        end
      }

      if llist.length == 1
        @layers.push(MapLayerFast.new(@tsize, @tpixels, px, py, llist[0], blist[0]), true)
      else
        (llist.length-1).times{|c|
          @layers.push(MapLayerFast.new(@tsize, @tpixels, px, py, llist[c], blist[llist.length - 1 - c], true))
        }
        @layers.push(MapLayerFast.new(@tsize, @tpixels, px, py, llist[llist.length-1], blist[0], false))
      end
      
      @w = @layers[0].w
      @h = @layers[0].h
    end
    
    def x=(v)
      if @loopX == false
        if @w * @tpixels - v <= Screen::Width
          return
        end
        @x = v
        if @x < 0
          @x = 0
        end
      else
        @x = v
        if @w * @tpixels - @x <= Screen::Width
          @x = @x % (@w * @tpixels)
        elsif @x < 0
          @x = @w * @tpixels + @x
        end
      end
      @layers.each{|l|
        l.x = @x
      }
    end
    
    def y=(v)
      if @loopY == false
        if @h * @tpixels - v <= Screen::Height
          return
        end
        @y = v
        if @y < 0
          @y = 0
        end
      else
        @y = v
        if @h * @tpixels - @y <= Screen::Height
          @y = @y % (@h * @tpixels)
        elsif @y < 0
          @y = @h * @tpixels + @y
        end
      end
      @layers.each{|l|
        l.y = @y
      }
    end
    
    def dp
       @layer[0].dp
    end
    
    def dp=(d)
      @layers.each{|l|
        l.dp = d
      }
    end
    
    def setDPs(*dl)
      l = dl.length
      l = @layers.length if l > @layers.length
      l.length.times{|d|
        @layers[d].dp = dl[d]
      }
    end
    
    def layer(idx)
      @layers[idx]
    end
    
    def lastLayer
      @layers[@layers.length - 1]
    end
    
    def visible
      @layers[0].visible
    end
    
    def visible=(f)
      if @layers.length == 1
        @layers[0].visible = true
        return
      end
      @layers.each{|ll|
        ll.visible = f
      }
      lastLayer.visible = false
    end
    
    def getCode(x, y)
      lastLayer.getCode(x, y)
    end

    def dispose
      @layers.each{|l|
        l.dispose
        l = nil
      }
      @layers = Array.new
    end
  end
end
