=begin
Easy Game Scripting by Ruby "pre-release" Sample Script
Copyright (C) 2006  Cyross Makoto

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
=end

require 'egsr'

EGSR::setTitle("тܗpTvXNvg EGSR")

class Util
  def Util.a2d(dirs)
    [dirs[2] - dirs[1], dirs[0] - dirs[3]]
  end
end

class Spr
  def initialize(name, vp)
    @final = false
    @sp = EGSR::Sprite.load(name)
    @sp.setViewPort(vp.x, vp.y, vp.w, vp.h)
    @sp.x = 0
    @sp.y = 0
    @sp.visible = true
    @stride = 8
  end
  
  def rect
    @sp.rect
  end
  
  def adjustment(n, min, max, size)
    if n < min
      min
    elsif n + size > max
      max - size
    else
      n
    end
  end
  
  def update
    br = @sp.rect
    sr = @sp.viewPort

    dx, dy = Util.a2d(EGSR::Input.triggerDir)

    @sp.x = adjustment(@sp.x + dx * @stride, sr.x, sr.w, br.w)
    @sp.y = adjustment(@sp.y + dy * @stride, sr.y, sr.h, br.h)
    
    @final = EGSR::Input::quit? || EGSR::Input::pushedEscape? || EGSR::Input.pushedBtn[1] == 1
  end
  
  def final?
    @final
  end
end

def_viewport = EGSR::Rect.new(0, 0, 640, 480) # ́AixWAyWAAj̏
sp = Spr.new("ruby.png", def_viewport)
loop{
  EGSR::update()
  sp.update()
  if sp.final?()
    break
  end
}
